/* A Bison parser, made by GNU Bison 3.5.1.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "grammar.y"


/*
 * ufdbGuard is copyrighted (C) 2005-2023 by URLfilterDB B.V. with all rights reserved.
 *
 * Parts of the ufdbGuard daemon are based on squidGuard.
 * squidGuard is copyrighted (C) 1998 by
 * ElTele st AS, Oslo, Norway, with all rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License (version 2) as
 * published by the Free Software Foundation.  It is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License (GPL) for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * (GPL2) along with this program.
 */

#define YYMALLOC  ufdbMalloc
#define YYFREE    ufdbFree

#define UFDB_LOG_USER_QUOTA   0   /* TODO remove */

#undef UFDB_DEBUG_ACL_ACCESS
#define UFDB_DEBUG_ACL_ACCESS 0

#include "ufdb.h"
#include "sg.h"
#include "ufdb_globals.h"
#include "ufdblib.h"
#include "ufdbdb.h"
#include "ufdbchkport.h"

#define UFDB_DEBUG 0

#if UFDB_DEBUG
#undef YYDEBUG
#define YYDEBUG 1
#endif

#define UFDB_TIME_DEBUG 0

#if __linux__
#include <sys/mman.h>
#endif
#include <pthread.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <grp.h>
#include <syslog.h>
#include <signal.h>
#include <sched.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/socket.h>


extern FILE * yyin;
extern FILE * yyout;

int    lineno;

static int   numTimeElements = 0;
static int * TimeElementsEvents = NULL;

static int   time_switch = 0;
static int   date_switch = 0;

static void setDBhome( char * dbhome );
static void setAdministrator( char * value );
static void setLogdir( char * value );
static void setPidfile( char * value );
static void setRefreshUserlist( int nmin );
static void setRefreshDomainlist( int nmin );
static void setRefreshIPlist( int nmin );
static void ufdbSourceExecIPList( char * command );

static void ufdbSourceGroup( int groupType, char * groupName );
static void ufdbSourceUserQuota( const char * seconds, const char * sporadic, const char * renew );
static void ufdbSourceUser( char * user );
static void ufdbSourceUserList( char * file );
static void ufdbSourceExecUserList( char * command );

static void defSource( char * source );
static void defSourceEnd( void );
static struct Source * defSourceFindName( struct Source * slist, const char * name );
static void defSourceDomain( char * );
static void ufdbSourceEval( int method  );
static void defSourceIPV4List( char * file );
static void defSourceIPV6List( char * file );

static void ufdbCategoryCACertsFile( char * cacertsFile );
static void ufdbCategoryCACertsDir( char * cacertsDir );

static void sgIpv4( const char * name, int type, const char * file, int lineno );
static void sgIpv6( const char * addr, int type, const char * file, int line );

void ufdbFreeDomainDb( struct sgDb * dbp );

static void   ufdbAcl( const char * name, const char * value, int within );
static void   ufdbAclSetValue( const char * what, const char * value, int allowed );

static void   sgTime( char * );
static struct ufdbTime * sgTimeFindName( const char * name );
static void   sgTimeElementInit( void );
static void   sgTimeElementAdd( char *, char );
static void   sgTimeElementEnd( void );
static void   sgTimeElementClone( void );
static void   defSourceTime( char * name, int within );

static void   ufdbCategoryTime( char * name, int within );
static void   ufdbCategoryActiveBumping( int flag );
static void   ufdbCategoryBlockConnect( int flag );
static void   ufdbCategoryRewrite( char * value );
static void   ufdbCategoryRedirect( char * value );
static void   ufdbCategoryExecDomainList( char * command );

static void   ufdbCategoryUrlList( char * urllist );
static void   ufdbCategoryOption( int value, int option );

static void   sgRewrite( char * rewrite );
static void   sgRewriteTime( char * name, int within );
static void   sgRewriteSubstitute( char * string );
static struct sgRewrite * sgRewriteFindName( const char * name );

static void   logConfig( void );


#line 205 "grammar.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_GRAMMAR_TAB_H_INCLUDED
# define YY_YY_GRAMMAR_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ADMINISTRATOR = 258,
    QSTRING = 259,
    CHECK_PROXY_TUNNELS = 260,
    QUEUE_CHECKS = 261,
    AGGRESSIVE = 262,
    LOG_ONLY = 263,
    ON = 264,
    OFF = 265,
    CHAR_MINUS = 266,
    CHAR_I = 267,
    CHAR_EXCLAMATION = 268,
    IGNORECASE = 269,
    COMMA = 270,
    EQUAL = 271,
    PORT = 272,
    HTTP_SERVER = 273,
    INTERFACE = 274,
    IMAGES = 275,
    HTTPS_PROHIBIT_INSECURE_SSLV2 = 276,
    HTTPS_PROHIBIT_INSECURE_SSLV3 = 277,
    HTTPS_PROHIBIT_INSECURE_TLSV1_0 = 278,
    HTTPS_CONNECTION_CACHE_SIZE = 279,
    IDENTIFIER = 280,
    WORD = 281,
    END = 282,
    START_BRACKET = 283,
    STOP_BRACKET = 284,
    WEEKDAY = 285,
    CATEGORY = 286,
    REWRITE = 287,
    ACL = 288,
    CPUS = 289,
    TIME = 290,
    TVAL = 291,
    DVAL = 292,
    DVALCRON = 293,
    BLOCK_BUMPED_CONNECT = 294,
    EVALUATE_AND = 295,
    EVALUATE_OR = 296,
    SOURCE = 297,
    CONTINUE = 298,
    IPV4ADDR = 299,
    IPV4NET = 300,
    IPV4CLASS = 301,
    IPV4RANGE = 302,
    IPV6ADDR = 303,
    IPV6NET = 304,
    DBHOME = 305,
    DOMAINLIST = 306,
    EXECDOMAINLIST = 307,
    REFRESHDOMAINLIST = 308,
    URLLIST = 309,
    EXPRESSIONLIST = 310,
    CACERTS = 311,
    CACERTSDIR = 312,
    IPV4 = 313,
    IPV4LIST = 314,
    IPV6 = 315,
    IPV6LIST = 316,
    DOMAIN = 317,
    UNIX = 318,
    LDAP = 319,
    USER = 320,
    USERLIST = 321,
    EXECUSERLIST = 322,
    REFRESHUSERLIST = 323,
    EXECIPLIST = 324,
    REFRESHIPLIST = 325,
    USERQUOTA = 326,
    GROUP = 327,
    NL = 328,
    NUMBER = 329,
    NUMBERS = 330,
    PASS = 331,
    REDIRECT = 332,
    SUBST = 333,
    CHAR = 334,
    MINUTELY = 335,
    HOURLY = 336,
    DAILY = 337,
    WEEKLY = 338,
    DATE = 339,
    REDIRECT_FATAL_ERROR = 340,
    REDIRECT_LOADING_DATABASE = 341,
    REDIRECT_HTTPS = 342,
    REDIRECT_BUMPED_HTTPS = 343,
    WITHIN = 344,
    OUTSIDE = 345,
    ELSE = 346,
    ANONYMOUS = 347,
    SPORADIC = 348,
    PIDFILE = 349,
    LOGFILE = 350,
    LOGDIR = 351,
    LOGPASS = 352,
    LOGBLOCK = 353,
    LOGALL = 354,
    LOGALL_HTTPD = 355,
    MAIL_SERVER = 356,
    MY_HOSTNAME = 357,
    ADMIN_EMAIL = 358,
    SENDER_EMAIL = 359,
    EXTERNAL_STATUS_COMMAND = 360,
    TOKEN_ALLOW = 361,
    TOKEN_DENY = 362,
    YOUTUBE_EDUFILTER = 363,
    YOUTUBE_EDUFILTER_ID = 364,
    ALLOW_GOOGLE_HTTPS_USING_IP = 365,
    URL_LOOKUP_RESULT_DB_RELOAD = 366,
    URL_LOOKUP_RESULT_FATAL_ERROR = 367,
    URL_LOOKUP_DELAY_DB_RELOAD = 368,
    OPTION = 369,
    UFDB_SHOW_URL_DETAILS = 370,
    UFDB_LOG_URL_DETAILS = 371,
    SQUID_VERSION = 372,
    SQUID_USES_ACTIVE_BUMPING = 373,
    UPLOAD_CRASH_REPORTS = 374,
    LOOKUP_REVERSE_IP = 375,
    USE_IPV6_ON_WAN = 376,
    PARSE_URL_PARAMETERS = 377,
    STRIP_DOMAIN_FROM_USERNAME = 378,
    UFDB_DEBUG_FILTER = 379,
    UFDB_DEBUG_COREDUMP = 380,
    MADVISE_HUGEPAGES = 381,
    FAST_REFRESH = 382,
    UFDB_DEBUG_SKYPE_PROBES = 383,
    UFDB_DEBUG_GTALK_PROBES = 384,
    UFDB_DEBUG_YAHOOMSG_PROBES = 385,
    UFDB_DEBUG_AIM_PROBES = 386,
    UFDB_DEBUG_FBCHAT_PROBES = 387,
    UFDB_DEBUG_CITRIXONLINE_PROBES = 388,
    UFDB_EXPRESSION_OPTIMISATION = 389,
    UFDB_EXPRESSION_DEBUG = 390,
    UFDB_DEBUG_EXTERNAL_SCRIPTS = 391,
    UFDB_NUM_WORKER_THREADS = 392,
    ENFORCE_HTTPS_WITH_HOSTNAME = 393,
    ENFORCE_HTTPS_OFFICAL_CERTIFICATE = 394,
    ALLOW_SKYPE_OVER_HTTPS = 395,
    ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS = 396,
    ALLOW_GTALK_OVER_HTTPS = 397,
    ALLOW_YAHOOMSG_OVER_HTTPS = 398,
    ALLOW_AIM_OVER_HTTPS = 399,
    ALLOW_FBCHAT_OVER_HTTPS = 400,
    ALLOW_CITRIXONLINE_OVER_HTTPS = 401,
    ALLOW_ANYDESK_OVER_HTTPS = 402,
    ALLOW_TEAMVIEWER_OVER_HTTPS = 403,
    ANALYSE_UNCATEGORISED = 404,
    LOG_UNCATEGORISED_URLS = 405,
    UPLOAD_STATS = 406,
    SAFE_SEARCH = 407,
    MAX_LOGFILE_SIZE = 408
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 136 "grammar.y"

  char * string;
  char * tval;
  char * dval;
  char * dvalcron;
  int    integer;

#line 419 "grammar.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_GRAMMAR_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   569

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  154
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  119
/* YYNRULES -- Number of rules.  */
#define YYNRULES  347
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  513

#define YYUNDEFTOK  2
#define YYMAXUTOK   408


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   226,   226,   230,   231,   235,   240,   241,   245,   246,
     247,   251,   255,   259,   263,   267,   271,   275,   279,   283,
     287,   288,   293,   297,   303,   309,   315,   321,   328,   329,
     330,   331,   335,   339,   343,   344,   348,   353,   358,   363,
     367,   371,   375,   380,   403,   408,   413,   418,   423,   428,
     432,   436,   440,   444,   448,   452,   456,   460,   464,   468,
     472,   476,   480,   484,   488,   493,   494,   498,   499,   503,
     514,   526,   530,   531,   535,   540,   545,   550,   555,   560,
     567,   572,   580,   587,   592,   605,   606,   612,   618,   619,
     620,   624,   625,   629,   633,   634,   636,   638,   640,   645,
     649,   650,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   700,   702,   704,
     709,   713,   717,   718,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   737,   739,
     741,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   756,   759,   762,   765,   770,   771,   772,   773,
     777,   778,   779,   780,   784,   787,   788,   792,   793,   794,
     798,   800,   799,   805,   806,   810,   818,   819,   820,   821,
     822,   825,   828,   831,   837,   838,   839,   840,   841,   842,
     846,   847,   848,   852,   854,   856,   858,   863,   864,   865,
     869,   871,   876,   877,   881,   885,   886,   891,   892,   893,
     894,   897,   900,   903,   910,   914,   918,   919,   924,   924,
     924,   925,   925,   925,   926,   926,   926,   927,   927,   928,
     932,   932,   933,   937,   938,   939,   940,   941,   942,   945,
     948,   951,   955,   961,   962,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ADMINISTRATOR", "QSTRING",
  "CHECK_PROXY_TUNNELS", "QUEUE_CHECKS", "AGGRESSIVE", "LOG_ONLY", "ON",
  "OFF", "CHAR_MINUS", "CHAR_I", "CHAR_EXCLAMATION", "IGNORECASE", "COMMA",
  "EQUAL", "PORT", "HTTP_SERVER", "INTERFACE", "IMAGES",
  "HTTPS_PROHIBIT_INSECURE_SSLV2", "HTTPS_PROHIBIT_INSECURE_SSLV3",
  "HTTPS_PROHIBIT_INSECURE_TLSV1_0", "HTTPS_CONNECTION_CACHE_SIZE",
  "IDENTIFIER", "WORD", "END", "START_BRACKET", "STOP_BRACKET", "WEEKDAY",
  "CATEGORY", "REWRITE", "ACL", "CPUS", "TIME", "TVAL", "DVAL", "DVALCRON",
  "BLOCK_BUMPED_CONNECT", "EVALUATE_AND", "EVALUATE_OR", "SOURCE",
  "CONTINUE", "IPV4ADDR", "IPV4NET", "IPV4CLASS", "IPV4RANGE", "IPV6ADDR",
  "IPV6NET", "DBHOME", "DOMAINLIST", "EXECDOMAINLIST", "REFRESHDOMAINLIST",
  "URLLIST", "EXPRESSIONLIST", "CACERTS", "CACERTSDIR", "IPV4", "IPV4LIST",
  "IPV6", "IPV6LIST", "DOMAIN", "UNIX", "LDAP", "USER", "USERLIST",
  "EXECUSERLIST", "REFRESHUSERLIST", "EXECIPLIST", "REFRESHIPLIST",
  "USERQUOTA", "GROUP", "NL", "NUMBER", "NUMBERS", "PASS", "REDIRECT",
  "SUBST", "CHAR", "MINUTELY", "HOURLY", "DAILY", "WEEKLY", "DATE",
  "REDIRECT_FATAL_ERROR", "REDIRECT_LOADING_DATABASE", "REDIRECT_HTTPS",
  "REDIRECT_BUMPED_HTTPS", "WITHIN", "OUTSIDE", "ELSE", "ANONYMOUS",
  "SPORADIC", "PIDFILE", "LOGFILE", "LOGDIR", "LOGPASS", "LOGBLOCK",
  "LOGALL", "LOGALL_HTTPD", "MAIL_SERVER", "MY_HOSTNAME", "ADMIN_EMAIL",
  "SENDER_EMAIL", "EXTERNAL_STATUS_COMMAND", "TOKEN_ALLOW", "TOKEN_DENY",
  "YOUTUBE_EDUFILTER", "YOUTUBE_EDUFILTER_ID",
  "ALLOW_GOOGLE_HTTPS_USING_IP", "URL_LOOKUP_RESULT_DB_RELOAD",
  "URL_LOOKUP_RESULT_FATAL_ERROR", "URL_LOOKUP_DELAY_DB_RELOAD", "OPTION",
  "UFDB_SHOW_URL_DETAILS", "UFDB_LOG_URL_DETAILS", "SQUID_VERSION",
  "SQUID_USES_ACTIVE_BUMPING", "UPLOAD_CRASH_REPORTS", "LOOKUP_REVERSE_IP",
  "USE_IPV6_ON_WAN", "PARSE_URL_PARAMETERS", "STRIP_DOMAIN_FROM_USERNAME",
  "UFDB_DEBUG_FILTER", "UFDB_DEBUG_COREDUMP", "MADVISE_HUGEPAGES",
  "FAST_REFRESH", "UFDB_DEBUG_SKYPE_PROBES", "UFDB_DEBUG_GTALK_PROBES",
  "UFDB_DEBUG_YAHOOMSG_PROBES", "UFDB_DEBUG_AIM_PROBES",
  "UFDB_DEBUG_FBCHAT_PROBES", "UFDB_DEBUG_CITRIXONLINE_PROBES",
  "UFDB_EXPRESSION_OPTIMISATION", "UFDB_EXPRESSION_DEBUG",
  "UFDB_DEBUG_EXTERNAL_SCRIPTS", "UFDB_NUM_WORKER_THREADS",
  "ENFORCE_HTTPS_WITH_HOSTNAME", "ENFORCE_HTTPS_OFFICAL_CERTIFICATE",
  "ALLOW_SKYPE_OVER_HTTPS", "ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS",
  "ALLOW_GTALK_OVER_HTTPS", "ALLOW_YAHOOMSG_OVER_HTTPS",
  "ALLOW_AIM_OVER_HTTPS", "ALLOW_FBCHAT_OVER_HTTPS",
  "ALLOW_CITRIXONLINE_OVER_HTTPS", "ALLOW_ANYDESK_OVER_HTTPS",
  "ALLOW_TEAMVIEWER_OVER_HTTPS", "ANALYSE_UNCATEGORISED",
  "LOG_UNCATEGORISED_URLS", "UPLOAD_STATS", "SAFE_SEARCH",
  "MAX_LOGFILE_SIZE", "$accept", "start", "qidentifier",
  "https_cache_size", "allow_or_deny", "on_or_off", "log_pass",
  "log_block", "log_all", "logall_httpd", "youtube_edufilter",
  "youtube_edufilter_id", "allow_google_https_using_ip",
  "madvise_hugepages", "fast_refresh", "debug_filter", "debug_coredump",
  "enforce_https_with_hostname", "enforce_https_offical_certificate",
  "https_prohibit_insecure_sslv2", "https_prohibit_insecure_sslv3",
  "https_prohibit_insecure_tlsv1_0", "check_proxy_tunnel_option",
  "check_proxy_tunnels", "admin_spec", "dbhome", "refreshuserlist",
  "refreshiplist", "refreshdomainlist", "url_lookup_result_db_reload",
  "url_lookup_result_fatal_error", "url_lookup_delay_db_reload",
  "squid_version", "num_worker_threads", "upload_crash_reports",
  "lookup_reverse_ip", "use_ipv6_on_wan", "parse_url_parameters",
  "squid_uses_active_bumping", "ufdb_log_url_details",
  "ufdb_show_url_details", "ufdb_debug_skype_probes",
  "ufdb_debug_gtalk_probes", "ufdb_debug_yahoomsg_probes",
  "ufdb_debug_aim_probes", "ufdb_debug_fbchat_probes",
  "ufdb_debug_citrixonline_probes", "ufdb_expression_optimisation",
  "ufdb_expression_debug", "ufdb_debug_external_scripts", "mail_server",
  "my_hostname", "admin_email", "sender_email", "external_status_command",
  "logdir", "pidfile", "port", "interface", "cpus", "upload_stats",
  "redirect_https", "redirect_bumped_https", "redirect_loading_database",
  "redirect_fatal_error", "log_uncategorised_urls",
  "analyse_uncategorised", "strip_domain_from_username", "safe_search",
  "max_logfile_size", "httpd_option", "httpd_options", "http_server_def",
  "category", "category_block", "category_contents", "category_content",
  "source", "source_block", "source_contents", "source_content", "domain",
  "user", "acl_block", "acl_contents", "acl_header", "acl_content", "$@1",
  "access_contents", "access_content", "access_pass", "ipv4s", "ipv4",
  "ipv6s", "ipv6", "rew", "rew_block", "rew_contents", "rew_content",
  "time", "time_block", "time_contents", "time_content", "$@2", "$@3",
  "$@4", "$@5", "$@6", "$@7", "$@8", "ttime", "$@9", "date", "dval",
  "tval", "dvalcron", "an_error", "statements", "statement", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408
};
# endif

#define YYPACT_NINF (-290)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-261)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -290,    18,    67,  -290,  -290,    26,     7,   -73,    43,    72,
     214,   214,   214,     5,    15,   100,    66,    31,   114,   114,
     134,    22,    33,    45,  -290,    88,   120,   130,   139,   205,
     249,   214,   214,   214,   214,   152,   158,   170,   225,   232,
     214,   234,   214,   143,   143,   214,   214,   214,   239,   214,
     214,   214,   214,   214,   214,    68,   214,   214,   214,   214,
     214,   214,   214,   214,   214,   214,   214,   214,    73,   214,
     214,   140,   214,   214,   214,   198,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,   251,  -290,   259,  -290,  -290,   264,  -290,   266,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,   356,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,   300,
     301,   321,   295,   331,    83,   417,   474,   144,    74,   288,
     107,   303,   356,  -290,  -290,   -16,  -290,  -290,  -290,   305,
     221,   114,   231,   294,   307,   314,   355,   114,   114,     3,
     260,  -290,  -290,  -290,  -290,  -290,  -290,   357,  -290,   384,
    -290,    64,  -290,   407,   114,   114,   291,   411,   114,   114,
      56,  -290,  -290,  -290,   114,   114,    89,  -290,  -290,  -290,
       1,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,   114,   114,    51,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,   416,   422,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,   430,  -290,   214,
     214,   214,   214,   214,   214,   362,   434,   214,   214,   214,
     214,   214,   214,   214,   214,   214,   214,   256,  -290,  -290,
     -13,  -290,  -290,   233,  -290,   454,   456,   289,  -290,  -290,
    -290,  -290,   296,  -290,  -290,  -290,  -290,  -290,   471,  -290,
    -290,  -290,  -290,   473,  -290,   339,   114,   348,   203,   349,
     358,   298,   483,  -290,   496,   119,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,   277,  -290,  -290,  -290,  -290,  -290,   228,  -290,  -290,
    -290,  -290,  -290,  -290,   289,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,   253,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,    -3,   354,  -290,  -290,  -290,  -290,  -290,
     540,  -290,  -290,  -290,   500,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,   354,   354,   354,   360,  -290,   385,   374,   385,
     364,  -290,   106,  -290,  -290,  -290,  -290,   385,   385,   385,
     354,   354,   354,  -290,  -290,  -290,   385,   412,  -290,   178,
     354,  -290,  -290
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
     273,     0,     0,     1,   272,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   346,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   280,   282,   283,   284,
     285,   339,   341,   340,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   281,   279,   295,   323,   324,   325,   304,
     305,   303,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   326,
     298,   299,   300,   301,   302,   296,   297,   328,   327,   329,
     330,   331,   332,   333,   334,   336,   335,   338,   337,   342,
     278,   275,   277,     0,   276,   343,     0,   344,     0,   345,
     347,   274,    33,    29,    30,    31,    28,    32,    69,     0,
       4,     3,    71,    70,    10,     8,     9,    25,    26,    27,
       5,    98,    95,    96,    97,    94,   233,   232,   195,    72,
      73,   244,   150,    35,    34,    38,    36,    37,    78,    77,
      75,    76,    68,    67,    66,    65,    11,    12,    13,    14,
      60,    61,    62,    63,    64,    15,    16,    17,     6,     7,
      39,    40,    41,    50,    49,    42,    48,    44,    45,    46,
      47,    82,    21,    20,    22,    18,    19,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    43,    23,    24,    81,
      80,    79,    74,    83,    84,   100,   152,   235,   246,     0,
       0,     0,    92,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    93,   194,     0,   203,   196,    99,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   101,   151,   177,   178,   185,   220,     0,   227,     0,
     186,     0,   190,     0,     0,     0,     0,     0,     0,     0,
       0,   153,   234,   237,     0,     0,     0,   236,   259,   245,
     251,   257,   247,    85,    87,    88,    86,    90,    89,    91,
     197,     0,     0,     0,   123,   122,   104,   103,   102,   105,
     108,   107,   106,   111,     0,     0,   110,   109,   117,   116,
     119,   118,   121,   120,   124,   125,   149,     0,   148,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   171,   173,   172,
     174,   176,   175,   154,   190,     0,     0,   155,   158,   157,
     161,   162,     0,   164,   163,   179,   180,   184,     0,   183,
     238,   239,   243,     0,   242,     0,     0,     0,     0,     0,
       0,   200,     0,   214,     0,     0,   204,   113,   112,   115,
     114,   147,   146,   134,   135,   136,   126,   129,   127,   131,
     133,   137,   145,   138,   139,   140,   141,   142,   143,   144,
     128,     0,   223,   226,   225,   224,   221,     0,   230,   231,
     228,   189,   188,   187,   156,   160,   159,   166,   165,   193,
     192,   191,     0,   182,   181,   241,   240,   249,   252,   255,
     269,   271,   258,   264,   268,   198,   199,   201,   207,   206,
     205,   209,   208,   213,     0,   212,   222,   229,   170,   167,
     168,   169,     0,     0,     0,     0,   270,   263,     0,   267,
       0,   215,     0,   219,   216,   211,   210,   250,   253,   256,
     266,     0,     0,   203,   217,   218,   265,     0,   262,     0,
       0,   202,   261
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -290,  -290,    -9,  -290,   378,    -8,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,   162,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,    53,  -290,  -290,  -290,  -290,  -290,   -78,  -290,
    -290,  -290,    -2,  -290,    -7,  -290,  -290,  -290,  -290,  -290,
    -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,  -290,
    -256,  -290,  -290,   -57,  -289,  -290,  -290,  -290,  -290
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   451,    76,   210,   167,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,   157,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     252,   253,   140,   141,   142,   255,   281,   143,   144,   256,
     301,   373,   377,   145,   254,   266,   267,   490,   323,   406,
     470,   367,   436,   370,   440,   146,   147,   257,   307,   148,
     149,   258,   312,   395,   482,   396,   483,   397,   484,   398,
     487,   501,   462,   463,   488,   464,   150,     2,   151
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     163,   158,   437,   168,   169,   175,   177,   160,   485,   181,
     182,   184,   320,   153,   154,   155,   171,   156,     3,   160,
     193,   195,   172,   196,   197,   198,   199,  -254,   161,   346,
     152,  -248,   205,   486,   207,   438,   439,   212,   213,   214,
     161,   216,   217,   218,   219,   220,   221,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     160,   237,   238,   240,   241,   242,   243,    -2,     4,   164,
       5,   159,     6,   321,   322,   308,   160,   165,   166,   170,
     401,   161,   387,   402,     7,     8,     9,   160,    10,    11,
      12,    13,   188,   160,   178,   347,   185,   161,    14,    15,
      16,    17,    18,   309,   160,   179,   180,   186,   161,    19,
     160,   160,   264,   504,   161,   392,   162,    20,   160,   187,
      21,   173,   174,   160,   189,   161,   176,   403,   404,   374,
     375,   161,   161,   314,   190,    22,   376,    23,   160,   161,
      24,   164,   222,   191,   161,   473,   405,   236,   388,   165,
     166,   315,    25,    26,    27,    28,   200,   310,   311,   161,
     183,    29,   201,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,   302,   202,    40,    41,    42,    43,    44,
      45,   393,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,   511,   489,   160,
     402,   474,   507,   508,   239,   164,    71,    72,    73,    74,
      75,   512,   303,   165,   166,   160,   497,   498,   499,   203,
     161,   192,   326,   304,   305,   160,   204,   160,   206,   306,
     460,   461,   330,   215,   506,   265,   161,   327,   441,   208,
     209,   316,   318,   160,   403,   404,   161,   331,   161,   442,
     325,   328,   329,   332,   337,   339,   341,   343,   344,   345,
     348,   431,   244,   405,   161,   194,   438,   439,   369,   245,
     372,   349,   350,   351,   379,   380,   381,   246,   384,   385,
     386,   389,   247,   160,   248,   390,   391,   394,   160,   352,
     432,   433,   434,   435,   449,   333,   334,   160,   335,   160,
     262,   160,   399,   400,   161,   450,   259,   260,   160,   161,
     336,   432,   433,   434,   435,   408,   410,   478,   161,   317,
     161,   324,   161,   338,   479,   480,   481,   261,   412,   161,
     340,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   160,
     263,   160,   313,   164,   443,   382,   446,   448,   353,   457,
     452,   165,   166,   249,   459,   250,   251,   465,   354,   454,
     161,   342,   161,   368,   456,   502,   466,   458,   160,   467,
     486,  -130,   503,   469,  -130,   472,   475,   460,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   161,
     371,   160,   366,  -130,  -130,   160,  -130,  -130,  -130,  -130,
     160,  -260,   211,   510,   319,   509,   160,   444,   500,   476,
     477,     0,   161,   378,   160,   164,   161,   383,     0,  -130,
       0,   161,   407,   165,   166,     0,   268,   161,   409,   269,
       0,  -130,  -130,     0,     0,   161,   411,  -130,   160,     0,
     160,   494,     0,  -132,     0,   496,  -132,     0,   270,   271,
       0,   272,   273,   274,   275,   160,  -130,   160,     0,   161,
     445,   161,   447,   505,     0,  -132,  -132,   160,  -132,  -132,
    -132,  -132,     0,     0,   276,     0,   161,   453,   161,   455,
     160,     0,     0,   282,   160,     0,   277,   278,   161,   468,
       0,  -132,   279,     0,   283,   284,     0,   285,     0,     0,
       0,   161,   471,  -132,  -132,   161,   495,     0,     0,  -132,
       0,   280,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,     0,   295,   160,   296,   297,   491,  -132,     0,
       0,     0,     0,   492,     0,   493,     0,     0,     0,     0,
       0,     0,     0,   298,   299,   161,     0,     0,     0,   300
};

static const yytype_int16 yycheck[] =
{
       9,    74,    15,    11,    12,    14,    15,     4,    11,    18,
      19,    20,    28,     6,     7,     8,     1,    10,     0,     4,
      29,    30,     7,    31,    32,    33,    34,    26,    25,    26,
       4,    30,    40,    36,    42,    48,    49,    45,    46,    47,
      25,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
       4,    69,    70,    71,    72,    73,    74,     0,     1,     1,
       3,    28,     5,    89,    90,     1,     4,     9,    10,    74,
      29,    25,    26,    32,    17,    18,    19,     4,    21,    22,
      23,    24,     4,     4,    28,    92,    74,    25,    31,    32,
      33,    34,    35,    29,     4,    74,    75,    74,    25,    42,
       4,     4,    29,     7,    25,    26,    44,    50,     4,    74,
      53,   106,   107,     4,     4,    25,    26,    76,    77,    65,
      66,    25,    25,    26,     4,    68,    72,    70,     4,    25,
      73,     1,    74,     4,    25,    26,    95,    74,    92,     9,
      10,    44,    85,    86,    87,    88,     4,    83,    84,    25,
      26,    94,     4,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    29,     4,   108,   109,   110,   111,   112,
     113,    92,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    29,   464,     4,
      32,    92,   501,   502,    74,     1,   149,   150,   151,   152,
     153,   510,    78,     9,    10,     4,   482,   483,   484,     4,
      25,    26,    11,    89,    90,     4,     4,     4,     4,    95,
      37,    38,    11,     4,   500,   254,    25,    26,    15,   106,
     107,   260,   261,     4,    76,    77,    25,    26,    25,    26,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    15,    74,    95,    25,    26,    48,    49,   287,    28,
     289,    21,    22,    23,   293,   294,   295,    28,   297,   298,
     299,   300,    28,     4,    28,   304,   305,   306,     4,    39,
      44,    45,    46,    47,    15,    11,    12,     4,    14,     4,
      15,     4,   321,   322,    25,    26,    16,    16,     4,    25,
      26,    44,    45,    46,    47,   334,   335,    74,    25,    26,
      25,    26,    25,    26,    81,    82,    83,    16,   347,    25,
      26,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     4,
      29,     4,    74,     1,   373,    74,   375,   376,   108,    30,
      74,     9,    10,    17,    26,    19,    20,    28,   118,   388,
      25,    26,    25,    26,   393,    11,    28,   396,     4,    91,
      36,    29,    28,   402,    32,   404,   405,    37,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    25,
      26,     4,   152,    51,    52,     4,    54,    55,    56,    57,
       4,    36,    44,    11,   262,   503,     4,   374,   485,   431,
     437,    -1,    25,    26,     4,     1,    25,    26,    -1,    77,
      -1,    25,    26,     9,    10,    -1,    29,    25,    26,    32,
      -1,    89,    90,    -1,    -1,    25,    26,    95,     4,    -1,
       4,   470,    -1,    29,    -1,   474,    32,    -1,    51,    52,
      -1,    54,    55,    56,    57,     4,   114,     4,    -1,    25,
      26,    25,    26,   492,    -1,    51,    52,     4,    54,    55,
      56,    57,    -1,    -1,    77,    -1,    25,    26,    25,    26,
       4,    -1,    -1,    29,     4,    -1,    89,    90,    25,    26,
      -1,    77,    95,    -1,    40,    41,    -1,    43,    -1,    -1,
      -1,    25,    26,    89,    90,    25,    26,    -1,    -1,    95,
      -1,   114,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    -1,    69,     4,    71,    72,     7,   114,    -1,
      -1,    -1,    -1,    13,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    90,    25,    -1,    -1,    -1,    95
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   155,   271,     0,     1,     3,     5,    17,    18,    19,
      21,    22,    23,    24,    31,    32,    33,    34,    35,    42,
      50,    53,    68,    70,    73,    85,    86,    87,    88,    94,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     108,   109,   110,   111,   112,   113,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   149,   150,   151,   152,   153,   157,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     226,   227,   228,   231,   232,   237,   249,   250,   253,   254,
     270,   272,     4,     6,     7,     8,    10,   176,    74,    28,
       4,    25,    44,   156,     1,     9,    10,   159,   159,   159,
      74,     1,     7,   106,   107,   156,    26,   156,    28,    74,
      75,   156,   156,    26,   156,    74,    74,    74,     4,     4,
       4,     4,    26,   156,    26,   156,   159,   159,   159,   159,
       4,     4,     4,     4,     4,   159,     4,   159,   106,   107,
     158,   158,   159,   159,   159,     4,   159,   159,   159,   159,
     159,   159,    74,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,    74,   159,   159,    74,
     159,   159,   159,   159,    74,    28,    28,    28,    28,    17,
      19,    20,   224,   225,   238,   229,   233,   251,   255,    16,
      16,    16,    15,    29,    29,   156,   239,   240,    29,    32,
      51,    52,    54,    55,    56,    57,    77,    89,    90,    95,
     114,   230,    29,    40,    41,    43,    58,    59,    60,    61,
      62,    63,    65,    66,    67,    69,    71,    72,    89,    90,
      95,   234,    29,    78,    89,    90,    95,   252,     1,    29,
      83,    84,   256,    74,    26,    44,   156,    26,   156,   225,
      28,    89,    90,   242,    26,   156,    11,    26,   156,   156,
      11,    26,   156,    11,    12,    14,    26,   156,    26,   156,
      26,   156,    26,   156,   156,   156,    26,    92,   156,    21,
      22,    23,    39,   108,   118,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   152,   245,    26,   156,
     247,    26,   156,   235,    65,    66,    72,   236,    26,   156,
     156,   156,    74,    26,   156,   156,   156,    26,    92,   156,
     156,   156,    26,    92,   156,   257,   259,   261,   263,   156,
     156,    29,    32,    76,    77,    95,   243,    26,   156,    26,
     156,    26,   156,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,    15,    44,    45,    46,    47,   246,    15,    48,    49,
     248,    15,    26,   156,   236,    26,   156,    26,   156,    15,
      26,   156,    74,    26,   156,    26,   156,    30,   156,    26,
      37,    38,   266,   267,   269,    28,    28,    91,    26,   156,
     244,    26,   156,    26,    92,   156,   246,   248,    74,    81,
      82,    83,   258,   260,   262,    11,    36,   264,   268,   264,
     241,     7,    13,    15,   156,    26,   156,   264,   264,   264,
     267,   265,    11,    28,     7,   156,   264,   268,   268,   242,
      11,    29,   268
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   154,   155,   156,   156,   157,   158,   158,   159,   159,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   169,   170,   171,   172,   173,   174,   175,   176,   176,
     176,   176,   177,   178,   179,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   209,   210,   210,   211,
     212,   212,   213,   213,   214,   215,   216,   217,   218,   219,
     220,   220,   221,   222,   223,   224,   224,   224,   224,   224,
     224,   225,   225,   226,   227,   227,   227,   227,   227,   228,
     229,   229,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     231,   232,   233,   233,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   235,   235,   235,   235,
     236,   236,   236,   236,   237,   238,   238,   239,   239,   239,
     240,   241,   240,   242,   242,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   244,   244,   244,   244,   244,   244,
     245,   245,   245,   246,   246,   246,   246,   247,   247,   247,
     248,   248,   249,   249,   250,   251,   251,   252,   252,   252,
     252,   252,   252,   252,   253,   254,   255,   255,   257,   258,
     256,   259,   260,   256,   261,   262,   256,   263,   256,   256,
     265,   264,   264,   266,   266,   266,   266,   266,   266,   267,
     268,   269,   270,   271,   271,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     1,     4,     2,     2,     2,     2,     2,     4,
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       2,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       2,     4,     0,     2,     2,     2,     3,     2,     2,     3,
       3,     2,     2,     2,     2,     3,     3,     4,     4,     4,
       4,     2,     2,     2,     2,     2,     2,     1,     1,     2,
       2,     3,     3,     2,     2,     1,     0,     2,     2,     2,
       0,     2,     2,     2,     4,     0,     2,     2,     4,     4,
       3,     0,     8,     0,     2,     2,     2,     2,     2,     2,
       3,     3,     2,     2,     0,     2,     2,     3,     3,     2,
       0,     2,     3,     1,     1,     1,     1,     0,     2,     3,
       1,     1,     2,     2,     4,     0,     2,     1,     2,     2,
       3,     3,     2,     2,     2,     4,     0,     2,     0,     0,
       5,     0,     0,     5,     0,     0,     5,     0,     3,     1,
       0,     5,     3,     2,     1,     4,     3,     2,     1,     1,
       1,     1,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[+yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[+*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3:
#line 230 "grammar.y"
                                { (yyval.string) = (yyvsp[0].string); }
#line 2071 "grammar.tab.c"
    break;

  case 4:
#line 231 "grammar.y"
                                { (yyval.string) = (yyvsp[0].string); }
#line 2077 "grammar.tab.c"
    break;

  case 5:
#line 235 "grammar.y"
                                                       { ufdbNewGV.httpsConnectionCacheSize = atoi( (yyvsp[0].string) );
		                                         ufdbFree( (yyvsp[0].string) ); }
#line 2084 "grammar.tab.c"
    break;

  case 6:
#line 240 "grammar.y"
                                { (yyval.integer) = UFDB_ALLOW; }
#line 2090 "grammar.tab.c"
    break;

  case 7:
#line 241 "grammar.y"
                                { (yyval.integer) = UFDB_DENY; }
#line 2096 "grammar.tab.c"
    break;

  case 8:
#line 245 "grammar.y"
                        { (yyval.integer) = 1; }
#line 2102 "grammar.tab.c"
    break;

  case 9:
#line 246 "grammar.y"
                        { (yyval.integer) = 0; }
#line 2108 "grammar.tab.c"
    break;

  case 10:
#line 247 "grammar.y"
                        { ufdbLogFatalError( "syntax error at line %d: expected 'on' or 'off'", lineno );   }
#line 2114 "grammar.tab.c"
    break;

  case 11:
#line 251 "grammar.y"
                                        { ufdbNewGV.logPass = (yyvsp[0].integer); }
#line 2120 "grammar.tab.c"
    break;

  case 12:
#line 255 "grammar.y"
                                        { ufdbNewGV.logBlock = (yyvsp[0].integer); }
#line 2126 "grammar.tab.c"
    break;

  case 13:
#line 259 "grammar.y"
                                        { ufdbNewGV.logAllRequests = (yyvsp[0].integer); }
#line 2132 "grammar.tab.c"
    break;

  case 14:
#line 263 "grammar.y"
                                                 { ufdbNewGV.debugHttpd = (yyvsp[0].integer); }
#line 2138 "grammar.tab.c"
    break;

  case 15:
#line 267 "grammar.y"
                                                 { ufdbNewGV.YoutubeEdufilter = (yyvsp[0].integer); }
#line 2144 "grammar.tab.c"
    break;

  case 16:
#line 271 "grammar.y"
                                                 { ufdbNewGV.YoutubeEdufilterID = (yyvsp[0].string); }
#line 2150 "grammar.tab.c"
    break;

  case 17:
#line 275 "grammar.y"
                                                          { ufdbNewGV.allowGoogleHTTPSusingIP = (yyvsp[0].integer); }
#line 2156 "grammar.tab.c"
    break;

  case 18:
#line 279 "grammar.y"
                                                { ufdbNewGV.madviseHugePages = (yyvsp[0].integer); }
#line 2162 "grammar.tab.c"
    break;

  case 19:
#line 283 "grammar.y"
                                                { ufdbNewGV.fastRefresh = (yyvsp[0].integer); }
#line 2168 "grammar.tab.c"
    break;

  case 20:
#line 287 "grammar.y"
                                                { ufdbNewGV.debug = ufdbGV.debug = (yyvsp[0].integer); }
#line 2174 "grammar.tab.c"
    break;

  case 21:
#line 288 "grammar.y"
                                                { ufdbNewGV.debug = ufdbGV.debug = atoi( (yyvsp[0].string) );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2181 "grammar.tab.c"
    break;

  case 22:
#line 293 "grammar.y"
                                                { ufdbNewGV.debugCoreDump = (yyvsp[0].integer); }
#line 2187 "grammar.tab.c"
    break;

  case 23:
#line 298 "grammar.y"
                    { ufdbLogError( "line %d: option enforce-https-with-hostname must be part of "
                                    "the security category", lineno );  }
#line 2194 "grammar.tab.c"
    break;

  case 24:
#line 304 "grammar.y"
                  { ufdbLogError( "line %d: option enforce-https-official-certificate must be part of "
                                  "the security category", lineno );  }
#line 2201 "grammar.tab.c"
    break;

  case 25:
#line 310 "grammar.y"
                    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv2 must be part of "
                                    "the security category", lineno );  }
#line 2208 "grammar.tab.c"
    break;

  case 26:
#line 316 "grammar.y"
                    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv3 must be part of "
                                    "the security category", lineno );  }
#line 2215 "grammar.tab.c"
    break;

  case 27:
#line 322 "grammar.y"
                    { ufdbLogError( "line %d: option https-prohibit-insecure-tlsv1_0 must be part of "
                                    "the security category", lineno );  }
#line 2222 "grammar.tab.c"
    break;

  case 28:
#line 328 "grammar.y"
                                { (yyval.integer) = UFDB_API_HTTPS_CHECK_OFF; }
#line 2228 "grammar.tab.c"
    break;

  case 29:
#line 329 "grammar.y"
                                { (yyval.integer) = UFDB_API_HTTPS_CHECK_QUEUE_CHECKS; }
#line 2234 "grammar.tab.c"
    break;

  case 30:
#line 330 "grammar.y"
                                { (yyval.integer) = UFDB_API_HTTPS_CHECK_AGGRESSIVE; }
#line 2240 "grammar.tab.c"
    break;

  case 31:
#line 331 "grammar.y"
                                { (yyval.integer) = UFDB_API_HTTPS_LOG_ONLY; }
#line 2246 "grammar.tab.c"
    break;

  case 32:
#line 335 "grammar.y"
                                                                { ufdbNewGV.tunnelCheckMethod = (yyvsp[0].integer); }
#line 2252 "grammar.tab.c"
    break;

  case 33:
#line 339 "grammar.y"
                                         { setAdministrator( (yyvsp[0].string) ); }
#line 2258 "grammar.tab.c"
    break;

  case 34:
#line 343 "grammar.y"
                                     { setDBhome( (yyvsp[0].string) ); }
#line 2264 "grammar.tab.c"
    break;

  case 35:
#line 344 "grammar.y"
                                     { setDBhome( (yyvsp[0].string) ); }
#line 2270 "grammar.tab.c"
    break;

  case 36:
#line 348 "grammar.y"
                                              { setRefreshUserlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2277 "grammar.tab.c"
    break;

  case 37:
#line 353 "grammar.y"
                                              { setRefreshIPlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2284 "grammar.tab.c"
    break;

  case 38:
#line 358 "grammar.y"
                                              { setRefreshDomainlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2291 "grammar.tab.c"
    break;

  case 39:
#line 364 "grammar.y"
                                        { ufdbNewGV.URLlookupResultDBreload = (yyvsp[0].integer); }
#line 2297 "grammar.tab.c"
    break;

  case 40:
#line 368 "grammar.y"
                                        { ufdbNewGV.URLlookupResultFatalError = (yyvsp[0].integer); }
#line 2303 "grammar.tab.c"
    break;

  case 41:
#line 372 "grammar.y"
                                        { ufdbNewGV.URLlookupDelayDBreload = (yyvsp[0].integer); }
#line 2309 "grammar.tab.c"
    break;

  case 42:
#line 376 "grammar.y"
                                        { ufdbFree( ufdbNewGV.SquidVersion );  ufdbNewGV.SquidVersion = (yyvsp[0].string);  }
#line 2315 "grammar.tab.c"
    break;

  case 43:
#line 381 "grammar.y"
                                        { int new_n_workers;
					  /* ONLY increase #workers */
					  new_n_workers = atoi( (yyvsp[0].string) );  
		                          ufdbFree( (yyvsp[0].string) );
					  if (new_n_workers < UFDB_MIN_THREADS)
					  {
					     ufdbLogError( "num-worker-threads must be at least %d",
                                                           UFDB_MIN_THREADS );
					     new_n_workers = UFDB_MIN_THREADS;
					  }
					  else if (new_n_workers > UFDB_MAX_THREADS)
					  {
					     ufdbLogError( "num-worker-threads can be at most %d",
                                                           UFDB_MAX_THREADS );
					     new_n_workers = UFDB_MAX_THREADS;
					  }
					  if (new_n_workers > ufdbNewGV.nWorkers)
					     ufdbNewGV.nWorkers = new_n_workers;
					}
#line 2339 "grammar.tab.c"
    break;

  case 44:
#line 404 "grammar.y"
                                        { ufdbNewGV.uploadCrashReports = (yyvsp[0].integer);  }
#line 2345 "grammar.tab.c"
    break;

  case 45:
#line 409 "grammar.y"
                                        { ufdbNewGV.lookupReverseIP = (yyvsp[0].integer);  }
#line 2351 "grammar.tab.c"
    break;

  case 46:
#line 414 "grammar.y"
                                        { ufdbNewGV.useAlsoIPv6onWan = (yyvsp[0].integer);  }
#line 2357 "grammar.tab.c"
    break;

  case 47:
#line 419 "grammar.y"
                                        { ufdbNewGV.parseURLparameters = (yyvsp[0].integer);  }
#line 2363 "grammar.tab.c"
    break;

  case 48:
#line 424 "grammar.y"
                                        { ufdbNewGV.SquidUsesActiveBumping = (yyvsp[0].integer);  }
#line 2369 "grammar.tab.c"
    break;

  case 49:
#line 428 "grammar.y"
                                                  { ufdbNewGV.logURLdetails = (yyvsp[0].integer); }
#line 2375 "grammar.tab.c"
    break;

  case 50:
#line 432 "grammar.y"
                                                   { ufdbNewGV.showURLdetails = (yyvsp[0].integer); }
#line 2381 "grammar.tab.c"
    break;

  case 51:
#line 436 "grammar.y"
                                                     { ufdbNewGV.debugSkype = (yyvsp[0].integer); }
#line 2387 "grammar.tab.c"
    break;

  case 52:
#line 440 "grammar.y"
                                                     { ufdbNewGV.debugGtalk = (yyvsp[0].integer); }
#line 2393 "grammar.tab.c"
    break;

  case 53:
#line 444 "grammar.y"
                                                        { ufdbNewGV.debugYahooMsg = (yyvsp[0].integer); }
#line 2399 "grammar.tab.c"
    break;

  case 54:
#line 448 "grammar.y"
                                                   { ufdbNewGV.debugAim = (yyvsp[0].integer); }
#line 2405 "grammar.tab.c"
    break;

  case 55:
#line 452 "grammar.y"
                                                      { ufdbNewGV.debugFBchat = (yyvsp[0].integer); }
#line 2411 "grammar.tab.c"
    break;

  case 56:
#line 456 "grammar.y"
                                                            { ufdbNewGV.debugCitrixOnline = (yyvsp[0].integer); }
#line 2417 "grammar.tab.c"
    break;

  case 57:
#line 460 "grammar.y"
                                                          { ufdbNewGV.expressionOptimisation = (yyvsp[0].integer); }
#line 2423 "grammar.tab.c"
    break;

  case 58:
#line 464 "grammar.y"
                                                   { ufdbNewGV.debugRegexp = (yyvsp[0].integer); }
#line 2429 "grammar.tab.c"
    break;

  case 59:
#line 468 "grammar.y"
                                                         { ufdbNewGV.debugExternalScripts = (yyvsp[0].integer); }
#line 2435 "grammar.tab.c"
    break;

  case 60:
#line 472 "grammar.y"
                                       { ufdbFree( ufdbNewGV.emailServer ); ufdbNewGV.emailServer = (yyvsp[0].string); }
#line 2441 "grammar.tab.c"
    break;

  case 61:
#line 476 "grammar.y"
                                       { ufdbFree( ufdbNewGV.myHostname ); ufdbNewGV.myHostname = (yyvsp[0].string); }
#line 2447 "grammar.tab.c"
    break;

  case 62:
#line 480 "grammar.y"
                                       { ufdbFree( ufdbNewGV.adminEmail ); ufdbNewGV.adminEmail = (yyvsp[0].string); }
#line 2453 "grammar.tab.c"
    break;

  case 63:
#line 484 "grammar.y"
                                       { ufdbFree( ufdbNewGV.senderEmail ); ufdbNewGV.senderEmail = (yyvsp[0].string); }
#line 2459 "grammar.tab.c"
    break;

  case 64:
#line 488 "grammar.y"
                                                    {  ufdbFree( ufdbNewGV.externalStatusCommand );  
		                                       ufdbNewGV.externalStatusCommand = (yyvsp[0].string); }
#line 2466 "grammar.tab.c"
    break;

  case 65:
#line 493 "grammar.y"
                                       { setLogdir( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2472 "grammar.tab.c"
    break;

  case 66:
#line 494 "grammar.y"
                                       { setLogdir( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2478 "grammar.tab.c"
    break;

  case 67:
#line 498 "grammar.y"
                                       { setPidfile( (yyvsp[0].string) ); }
#line 2484 "grammar.tab.c"
    break;

  case 68:
#line 499 "grammar.y"
                                       { setPidfile( (yyvsp[0].string) ); }
#line 2490 "grammar.tab.c"
    break;

  case 69:
#line 503 "grammar.y"
                                       { ufdbNewGV.portNum = atoi( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); 
                                         if (ufdbNewGV.portNum <= 0)
                                         {
                                            ufdbLogError( "port number must be > 0, using default port %d",
                                                          UFDB_DAEMON_PORT );
                                            ufdbNewGV.portNum = UFDB_DAEMON_PORT;
                                         }
                                       }
#line 2503 "grammar.tab.c"
    break;

  case 70:
#line 514 "grammar.y"
                                           { 
#if HAVE_UNIX_SOCKETS
                                             ufdbLogError( "ufdbguardd is configured to use UNIX sockets.  "
					                   "\"interface\" is ignored." );
#else
		                             if (strcmp( (yyvsp[0].string), "all" ) == 0)
						strcpy( ufdbNewGV.interface, "all" );    
					     else
					        ufdbLogFatalError( "interface must be \"all\" or IP address" );
#endif
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2520 "grammar.tab.c"
    break;

  case 71:
#line 526 "grammar.y"
                                     { strcpy( ufdbNewGV.interface, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2526 "grammar.tab.c"
    break;

  case 72:
#line 530 "grammar.y"
                                     { ufdbSetCPU( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2532 "grammar.tab.c"
    break;

  case 73:
#line 531 "grammar.y"
                                     { ufdbSetCPU( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2538 "grammar.tab.c"
    break;

  case 74:
#line 536 "grammar.y"
                     { ufdbNewGV.uploadStats = (yyvsp[0].integer);   }
#line 2544 "grammar.tab.c"
    break;

  case 75:
#line 541 "grammar.y"
                     { strcpy( ufdbNewGV.redirectHttps, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2550 "grammar.tab.c"
    break;

  case 76:
#line 546 "grammar.y"
                     { strcpy( ufdbNewGV.redirectBumpedHttps, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2556 "grammar.tab.c"
    break;

  case 77:
#line 551 "grammar.y"
                     { strcpy( ufdbNewGV.loadingDatabaseRedirect, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2562 "grammar.tab.c"
    break;

  case 78:
#line 556 "grammar.y"
                     { strcpy( ufdbNewGV.fatalErrorRedirect, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2568 "grammar.tab.c"
    break;

  case 79:
#line 561 "grammar.y"
                     {
			ufdbNewGV.logUncategorisedURLs = (yyvsp[0].integer);   
		     }
#line 2576 "grammar.tab.c"
    break;

  case 80:
#line 568 "grammar.y"
                     { 
			ufdbNewGV.analyseUncategorisedURLs = (yyvsp[0].integer);   
		     }
#line 2584 "grammar.tab.c"
    break;

  case 81:
#line 573 "grammar.y"
                     {
			ufdbNewGV.analyseUncategorisedURLs = atoi( (yyvsp[0].string) ); 
			ufdbFree( (yyvsp[0].string) ); 
		     }
#line 2593 "grammar.tab.c"
    break;

  case 82:
#line 581 "grammar.y"
                     {
		        ufdbNewGV.stripDomainFromUsername = (yyvsp[0].integer);
		     }
#line 2601 "grammar.tab.c"
    break;

  case 83:
#line 588 "grammar.y"
                     { ufdbNewGV.safeSearch = (yyvsp[0].integer); }
#line 2607 "grammar.tab.c"
    break;

  case 84:
#line 593 "grammar.y"
                     { 
		       ufdbNewGV.maxLogfileSize = strtoul( (yyvsp[0].string), NULL, 10 );
		       ufdbFree( (yyvsp[0].string) );
		       if (ufdbNewGV.maxLogfileSize < 2 * 1024 * 1024)		// minimum is 2 MB
		          ufdbNewGV.maxLogfileSize = 2 * 1024 * 1024;
		       if (ufdbNewGV.maxLogfileSize > 500000000000)	        // maximum is 500 GB
		          ufdbNewGV.maxLogfileSize = 500000000000;
                       ufdbGV.maxLogfileSize = ufdbNewGV.maxLogfileSize;        // we want immediate effect
		     }
#line 2621 "grammar.tab.c"
    break;

  case 85:
#line 605 "grammar.y"
                                           { ufdbNewGV.httpdPort = atoi( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2627 "grammar.tab.c"
    break;

  case 86:
#line 606 "grammar.y"
                                              { if (strcmp((yyvsp[0].string),"all")== 0)
						strcpy( ufdbNewGV.httpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2638 "grammar.tab.c"
    break;

  case 87:
#line 612 "grammar.y"
                                           { if (strcmp((yyvsp[0].string),"all")== 0)
						strcpy( ufdbNewGV.httpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2649 "grammar.tab.c"
    break;

  case 88:
#line 618 "grammar.y"
                                           { strcpy( ufdbNewGV.httpdInterface, (yyvsp[0].string) );       ufdbFree( (yyvsp[0].string) ); }
#line 2655 "grammar.tab.c"
    break;

  case 89:
#line 619 "grammar.y"
                                           { strcpy( ufdbNewGV.httpdImagesDirectory, (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2661 "grammar.tab.c"
    break;

  case 90:
#line 620 "grammar.y"
                                           { strcpy( ufdbNewGV.httpdImagesDirectory, (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2667 "grammar.tab.c"
    break;

  case 94:
#line 633 "grammar.y"
                                       { ufdbCategory( (yyvsp[0].string) ); }
#line 2673 "grammar.tab.c"
    break;

  case 95:
#line 634 "grammar.y"
                                       { ufdbCategory( ufdbStrdup("aggressive") );
		                         yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 2680 "grammar.tab.c"
    break;

  case 96:
#line 636 "grammar.y"
                                       { ufdbCategory( ufdbStrdup("allow") );
		                         yyerror( (char *) "\"allow\" is a keyword and must be surrounded by quotes" ); }
#line 2687 "grammar.tab.c"
    break;

  case 97:
#line 638 "grammar.y"
                                       { ufdbCategory( ufdbStrdup("deny") );
		                         yyerror( (char *) "\"deny\" is a keyword and must be surrounded by quotes" ); }
#line 2694 "grammar.tab.c"
    break;

  case 98:
#line 640 "grammar.y"
                                       { ufdbCategory( ufdbStrdup("syntax-error") );
		                         yyerror( (char *) "erroneous category definition.  Perhaps the category ID is a reserved word?" ); }
#line 2701 "grammar.tab.c"
    break;

  case 99:
#line 646 "grammar.y"
                       { ufdbCategoryEnd(); }
#line 2707 "grammar.tab.c"
    break;

  case 102:
#line 654 "grammar.y"
                                                        { ufdbCategoryDomainList( (yyvsp[0].string) ); }
#line 2713 "grammar.tab.c"
    break;

  case 103:
#line 655 "grammar.y"
                                                        { ufdbCategoryDomainList( (yyvsp[0].string) ); }
#line 2719 "grammar.tab.c"
    break;

  case 104:
#line 656 "grammar.y"
                                                        { ufdbCategoryDomainList( NULL ); }
#line 2725 "grammar.tab.c"
    break;

  case 105:
#line 657 "grammar.y"
                                                        { ufdbCategoryExecDomainList( (yyvsp[0].string) ); }
#line 2731 "grammar.tab.c"
    break;

  case 106:
#line 658 "grammar.y"
                                                        { ufdbCategoryUrlList( (yyvsp[0].string) ); }
#line 2737 "grammar.tab.c"
    break;

  case 107:
#line 659 "grammar.y"
                                                        { ufdbCategoryUrlList( (yyvsp[0].string) ); }
#line 2743 "grammar.tab.c"
    break;

  case 108:
#line 660 "grammar.y"
                                                        { ufdbCategoryUrlList( NULL ); }
#line 2749 "grammar.tab.c"
    break;

  case 109:
#line 661 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "n" ); }
#line 2755 "grammar.tab.c"
    break;

  case 110:
#line 662 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "n" ); }
#line 2761 "grammar.tab.c"
    break;

  case 111:
#line 663 "grammar.y"
                                                        { ufdbCategoryExpressionList( NULL, NULL ); }
#line 2767 "grammar.tab.c"
    break;

  case 112:
#line 664 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2773 "grammar.tab.c"
    break;

  case 113:
#line 665 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2779 "grammar.tab.c"
    break;

  case 114:
#line 666 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2785 "grammar.tab.c"
    break;

  case 115:
#line 667 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2791 "grammar.tab.c"
    break;

  case 116:
#line 668 "grammar.y"
                                                        { ufdbCategoryCACertsFile( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2797 "grammar.tab.c"
    break;

  case 117:
#line 669 "grammar.y"
                                                        { ufdbCategoryCACertsFile( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2803 "grammar.tab.c"
    break;

  case 118:
#line 670 "grammar.y"
                                                        { ufdbCategoryCACertsDir( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2809 "grammar.tab.c"
    break;

  case 119:
#line 671 "grammar.y"
                                                        { ufdbCategoryCACertsDir( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2815 "grammar.tab.c"
    break;

  case 120:
#line 672 "grammar.y"
                                                        { ufdbCategoryRedirect( (yyvsp[0].string) ); }
#line 2821 "grammar.tab.c"
    break;

  case 121:
#line 673 "grammar.y"
                                                        { ufdbCategoryRedirect( (yyvsp[0].string) ); }
#line 2827 "grammar.tab.c"
    break;

  case 122:
#line 674 "grammar.y"
                                                        { ufdbCategoryRewrite( (yyvsp[0].string) ); }
#line 2833 "grammar.tab.c"
    break;

  case 123:
#line 675 "grammar.y"
                                                        { ufdbCategoryRewrite( (yyvsp[0].string) ); }
#line 2839 "grammar.tab.c"
    break;

  case 124:
#line 676 "grammar.y"
                                                        { ufdbCategoryTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 2845 "grammar.tab.c"
    break;

  case 125:
#line 677 "grammar.y"
                                                        { ufdbCategoryTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 2851 "grammar.tab.c"
    break;

  case 126:
#line 678 "grammar.y"
                                                                     { ufdbCategoryBlockConnect( (yyvsp[0].integer) ); }
#line 2857 "grammar.tab.c"
    break;

  case 127:
#line 679 "grammar.y"
                                                                     { ufdbCategoryActiveBumping( (yyvsp[0].integer) ); }
#line 2863 "grammar.tab.c"
    break;

  case 128:
#line 680 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_SAFE_SEARCH );  }
#line 2869 "grammar.tab.c"
    break;

  case 129:
#line 681 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_YOUTUBE_EDUFILTER );  }
#line 2875 "grammar.tab.c"
    break;

  case 130:
#line 682 "grammar.y"
                                                                     { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
#line 2881 "grammar.tab.c"
    break;

  case 131:
#line 683 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
#line 2887 "grammar.tab.c"
    break;

  case 132:
#line 684 "grammar.y"
                                                                     { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
#line 2893 "grammar.tab.c"
    break;

  case 133:
#line 685 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
#line 2899 "grammar.tab.c"
    break;

  case 134:
#line 686 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV2 );  }
#line 2905 "grammar.tab.c"
    break;

  case 135:
#line 687 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV3 );  }
#line 2911 "grammar.tab.c"
    break;

  case 136:
#line 688 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_PROHIBIT_INSECURE_TLSV1_0 );  }
#line 2917 "grammar.tab.c"
    break;

  case 137:
#line 689 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_SKYPE_OVER_HTTPS );  }
#line 2923 "grammar.tab.c"
    break;

  case 138:
#line 690 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_GTALK_OVER_HTTPS );  }
#line 2929 "grammar.tab.c"
    break;

  case 139:
#line 691 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_YAHOOMSG_OVER_HTTPS );  }
#line 2935 "grammar.tab.c"
    break;

  case 140:
#line 692 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_AIM_OVER_HTTPS );  }
#line 2941 "grammar.tab.c"
    break;

  case 141:
#line 693 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_FBCHAT_OVER_HTTPS );  }
#line 2947 "grammar.tab.c"
    break;

  case 142:
#line 694 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_CITRIXONLINE_OVER_HTTPS );  }
#line 2953 "grammar.tab.c"
    break;

  case 143:
#line 695 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_ANYDESK_OVER_HTTPS );  }
#line 2959 "grammar.tab.c"
    break;

  case 144:
#line 696 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_TEAMVIEWER_OVER_HTTPS );  }
#line 2965 "grammar.tab.c"
    break;

  case 145:
#line 697 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS );  }
#line 2971 "grammar.tab.c"
    break;

  case 146:
#line 698 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2978 "grammar.tab.c"
    break;

  case 147:
#line 700 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2985 "grammar.tab.c"
    break;

  case 148:
#line 702 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2992 "grammar.tab.c"
    break;

  case 149:
#line 704 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2999 "grammar.tab.c"
    break;

  case 150:
#line 709 "grammar.y"
                                     { defSource( (yyvsp[0].string) ); }
#line 3005 "grammar.tab.c"
    break;

  case 151:
#line 713 "grammar.y"
                                                                    { defSourceEnd(); }
#line 3011 "grammar.tab.c"
    break;

  case 157:
#line 725 "grammar.y"
                                                 { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 3017 "grammar.tab.c"
    break;

  case 158:
#line 726 "grammar.y"
                                                 { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 3023 "grammar.tab.c"
    break;

  case 159:
#line 727 "grammar.y"
                                                 { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 3029 "grammar.tab.c"
    break;

  case 160:
#line 728 "grammar.y"
                                                 { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 3035 "grammar.tab.c"
    break;

  case 161:
#line 729 "grammar.y"
                                                 { ufdbSourceExecUserList( (yyvsp[0].string) ); }
#line 3041 "grammar.tab.c"
    break;

  case 162:
#line 730 "grammar.y"
                                                 { ufdbSourceExecIPList( (yyvsp[0].string) ); }
#line 3047 "grammar.tab.c"
    break;

  case 163:
#line 731 "grammar.y"
                                                 { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 3053 "grammar.tab.c"
    break;

  case 164:
#line 732 "grammar.y"
                                                 { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 3059 "grammar.tab.c"
    break;

  case 165:
#line 733 "grammar.y"
                                                 { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 3065 "grammar.tab.c"
    break;

  case 166:
#line 734 "grammar.y"
                                                 { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 3071 "grammar.tab.c"
    break;

  case 167:
#line 735 "grammar.y"
                                                 { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "3600" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 3078 "grammar.tab.c"
    break;

  case 168:
#line 737 "grammar.y"
                                                 { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "86400" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 3085 "grammar.tab.c"
    break;

  case 169:
#line 739 "grammar.y"
                                                 { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "604800" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 3092 "grammar.tab.c"
    break;

  case 170:
#line 741 "grammar.y"
                                                 { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), (yyvsp[0].string) );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 3099 "grammar.tab.c"
    break;

  case 172:
#line 744 "grammar.y"
                                                 { defSourceIPV4List( (yyvsp[0].string) ); }
#line 3105 "grammar.tab.c"
    break;

  case 173:
#line 745 "grammar.y"
                                                 { defSourceIPV4List( (yyvsp[0].string) ); }
#line 3111 "grammar.tab.c"
    break;

  case 175:
#line 747 "grammar.y"
                                                 { defSourceIPV6List( (yyvsp[0].string) ); }
#line 3117 "grammar.tab.c"
    break;

  case 176:
#line 748 "grammar.y"
                                                 { defSourceIPV6List( (yyvsp[0].string) ); }
#line 3123 "grammar.tab.c"
    break;

  case 177:
#line 749 "grammar.y"
                                                 { ufdbSourceEval( UFDB_EVAL_AND ); }
#line 3129 "grammar.tab.c"
    break;

  case 178:
#line 750 "grammar.y"
                                                 { ufdbSourceEval( UFDB_EVAL_OR ); }
#line 3135 "grammar.tab.c"
    break;

  case 179:
#line 751 "grammar.y"
                                                 { defSourceTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 3141 "grammar.tab.c"
    break;

  case 180:
#line 752 "grammar.y"
                                                 { defSourceTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 3147 "grammar.tab.c"
    break;

  case 181:
#line 753 "grammar.y"
                                                 { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3155 "grammar.tab.c"
    break;

  case 182:
#line 756 "grammar.y"
                                                 { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3163 "grammar.tab.c"
    break;

  case 183:
#line 759 "grammar.y"
                                                 { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3171 "grammar.tab.c"
    break;

  case 184:
#line 762 "grammar.y"
                                                 { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3179 "grammar.tab.c"
    break;

  case 185:
#line 765 "grammar.y"
                                                 { ufdbNewGV.lastSource->cont_search = 1; }
#line 3185 "grammar.tab.c"
    break;

  case 187:
#line 771 "grammar.y"
                                        { defSourceDomain( (yyvsp[0].string) ); }
#line 3191 "grammar.tab.c"
    break;

  case 188:
#line 772 "grammar.y"
                                        { defSourceDomain( (yyvsp[0].string) ); }
#line 3197 "grammar.tab.c"
    break;

  case 191:
#line 778 "grammar.y"
                                        { ufdbSourceUser( (yyvsp[0].string) ); }
#line 3203 "grammar.tab.c"
    break;

  case 192:
#line 779 "grammar.y"
                                        { ufdbSourceUser( (yyvsp[0].string) ); }
#line 3209 "grammar.tab.c"
    break;

  case 197:
#line 792 "grammar.y"
                                                                 { ufdbAcl( (yyvsp[-1].string), NULL, UFDB_ACL_NONE );  }
#line 3215 "grammar.tab.c"
    break;

  case 198:
#line 793 "grammar.y"
                                                                 { ufdbAcl( (yyvsp[-3].string), (yyvsp[-1].string), UFDB_ACL_WITHIN );  }
#line 3221 "grammar.tab.c"
    break;

  case 199:
#line 794 "grammar.y"
                                                                 { ufdbAcl( (yyvsp[-3].string), (yyvsp[-1].string), UFDB_ACL_OUTSIDE ); }
#line 3227 "grammar.tab.c"
    break;

  case 201:
#line 800 "grammar.y"
                     { ufdbAcl( NULL, NULL, UFDB_ACL_ELSE );    }
#line 3233 "grammar.tab.c"
    break;

  case 205:
#line 810 "grammar.y"
                                                { if (ufdbNewGV.lastAcl != NULL  &&  
                                                      ufdbNewGV.lastAcl->pass == NULL) 
                                                  {
                                                     ufdbLogMessage( "line %d: acl has an empty pass statement."
                                                                     "  Adding 'any'.", lineno );
                                                     ufdbAclSetValue( "pass", ufdbStrdup("any"), 1 );
                                                  }
                                                }
#line 3246 "grammar.tab.c"
    break;

  case 206:
#line 818 "grammar.y"
                                                { ufdbAclSetValue( "rewrite", (yyvsp[0].string), 0 ); }
#line 3252 "grammar.tab.c"
    break;

  case 207:
#line 819 "grammar.y"
                                                { ufdbAclSetValue( "rewrite", (yyvsp[0].string), 0 ); }
#line 3258 "grammar.tab.c"
    break;

  case 208:
#line 820 "grammar.y"
                                                { ufdbAclSetValue( "redirect", (yyvsp[0].string), 0 ); }
#line 3264 "grammar.tab.c"
    break;

  case 209:
#line 821 "grammar.y"
                                                { ufdbAclSetValue( "redirect", (yyvsp[0].string), 0 ); }
#line 3270 "grammar.tab.c"
    break;

  case 210:
#line 822 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3278 "grammar.tab.c"
    break;

  case 211:
#line 825 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3286 "grammar.tab.c"
    break;

  case 212:
#line 828 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3294 "grammar.tab.c"
    break;

  case 213:
#line 831 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3302 "grammar.tab.c"
    break;

  case 215:
#line 838 "grammar.y"
                                                            { yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 3308 "grammar.tab.c"
    break;

  case 216:
#line 839 "grammar.y"
                                                            { ufdbAclSetValue( "pass", (yyvsp[0].string), 1 ); }
#line 3314 "grammar.tab.c"
    break;

  case 217:
#line 840 "grammar.y"
                                                            { yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 3320 "grammar.tab.c"
    break;

  case 218:
#line 841 "grammar.y"
                                                            { ufdbAclSetValue( "pass", (yyvsp[0].string), 0 ); }
#line 3326 "grammar.tab.c"
    break;

  case 223:
#line 852 "grammar.y"
                                                { sgIpv4( (yyvsp[0].string), SG_IPTYPE_HOST, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) );  }
#line 3333 "grammar.tab.c"
    break;

  case 224:
#line 854 "grammar.y"
                                                { sgIpv4( (yyvsp[0].string), SG_IPTYPE_RANGE, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) );  }
#line 3340 "grammar.tab.c"
    break;

  case 225:
#line 856 "grammar.y"
                                                { sgIpv4( (yyvsp[0].string), SG_IPTYPE_CLASS, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 3347 "grammar.tab.c"
    break;

  case 226:
#line 858 "grammar.y"
                                                { sgIpv4( (yyvsp[0].string), SG_IPTYPE_CIDR, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 3354 "grammar.tab.c"
    break;

  case 230:
#line 869 "grammar.y"
                                                { sgIpv6( (yyvsp[0].string), SG_IPV6TYPE_HOST, ufdbNewGV.configFile, lineno );
                                                  ufdbFree( (yyvsp[0].string) );  }
#line 3361 "grammar.tab.c"
    break;

  case 231:
#line 871 "grammar.y"
                                                { sgIpv6( (yyvsp[0].string), SG_IPV6TYPE_CIDR, ufdbNewGV.configFile, lineno );
                                                  ufdbFree( (yyvsp[0].string) );  }
#line 3368 "grammar.tab.c"
    break;

  case 232:
#line 876 "grammar.y"
                                        { sgRewrite( (yyvsp[0].string) ); }
#line 3374 "grammar.tab.c"
    break;

  case 233:
#line 877 "grammar.y"
                                        { sgRewrite( (yyvsp[0].string) ); }
#line 3380 "grammar.tab.c"
    break;

  case 237:
#line 891 "grammar.y"
                                                { sgRewriteSubstitute( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 3386 "grammar.tab.c"
    break;

  case 238:
#line 892 "grammar.y"
                                                { sgRewriteTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 3392 "grammar.tab.c"
    break;

  case 239:
#line 893 "grammar.y"
                                                { sgRewriteTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 3398 "grammar.tab.c"
    break;

  case 240:
#line 894 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3406 "grammar.tab.c"
    break;

  case 241:
#line 897 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3414 "grammar.tab.c"
    break;

  case 242:
#line 900 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3422 "grammar.tab.c"
    break;

  case 243:
#line 903 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3430 "grammar.tab.c"
    break;

  case 244:
#line 910 "grammar.y"
                                                { sgTime( (yyvsp[0].string) ); }
#line 3436 "grammar.tab.c"
    break;

  case 248:
#line 924 "grammar.y"
                         { sgTimeElementInit(); }
#line 3442 "grammar.tab.c"
    break;

  case 249:
#line 924 "grammar.y"
                                                              { sgTimeElementAdd((yyvsp[0].string),T_WEEKDAY); }
#line 3448 "grammar.tab.c"
    break;

  case 251:
#line 925 "grammar.y"
                         { sgTimeElementInit(); }
#line 3454 "grammar.tab.c"
    break;

  case 252:
#line 925 "grammar.y"
                                                              { sgTimeElementAdd((yyvsp[0].string),T_WEEKLY); }
#line 3460 "grammar.tab.c"
    break;

  case 254:
#line 926 "grammar.y"
                         { sgTimeElementInit(); }
#line 3466 "grammar.tab.c"
    break;

  case 255:
#line 926 "grammar.y"
                                                              { sgTimeElementAdd((yyvsp[0].string),T_WEEKLY); }
#line 3472 "grammar.tab.c"
    break;

  case 257:
#line 927 "grammar.y"
                         { sgTimeElementInit(); }
#line 3478 "grammar.tab.c"
    break;

  case 258:
#line 927 "grammar.y"
                                                              { sgTimeElementEnd(); }
#line 3484 "grammar.tab.c"
    break;

  case 259:
#line 928 "grammar.y"
                         { ufdbLogFatalError( "invalid time specification at line %d", lineno );   }
#line 3490 "grammar.tab.c"
    break;

  case 260:
#line 932 "grammar.y"
                         { sgTimeElementClone(); }
#line 3496 "grammar.tab.c"
    break;

  case 269:
#line 945 "grammar.y"
                                { sgTimeElementAdd( (yyvsp[0].string), T_DVAL ); }
#line 3502 "grammar.tab.c"
    break;

  case 270:
#line 948 "grammar.y"
                                { sgTimeElementAdd( (yyvsp[0].tval), T_TVAL ); }
#line 3508 "grammar.tab.c"
    break;

  case 271:
#line 951 "grammar.y"
                                { sgTimeElementAdd( (yyvsp[0].string), T_DVALCRON ); }
#line 3514 "grammar.tab.c"
    break;

  case 272:
#line 955 "grammar.y"
                                {  yyerror( (char *) "syntax error" );  
                                   if (ufdbNewGV.serialno > 1  &&  ufdbNewGV.debug)
                                      logConfig(); 
                                }
#line 3523 "grammar.tab.c"
    break;


#line 3527 "grammar.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[+*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1041 "grammar.y"


int ufdbReadConfig( 
   const char *      file )
{
   struct Source *   source;
   struct Category * cat;
   struct Acl *      acl;

   lineno = 1;
   ufdbResetCPUs();

   ufdbNewGV.configFile = file;

   yyin = fopen( ufdbNewGV.configFile, "r" );
   if (yyin == NULL) 
   {
      syslog( LOG_ALERT, "%s: cannot open configuration file %s", ufdbNewGV.progname, ufdbNewGV.configFile );
      ufdbLogFatalError( "cannot open configuration file %s", ufdbNewGV.configFile );
      return 0;
   }

   ufdbLogMessage( "configuration file: %s", ufdbNewGV.configFile );

   /* keep the old HTTPS redirection URL.  It is most likely that we need it during the database reload */
   /* dot not reset ufdbNewGV.RedirectHttps and ufdbNewGV.RedirectBumpedHttps. */

   ufdbNewGV.debug = 0;
   ufdbNewGV.debugCoreDump = 0;
   strcpy( ufdbNewGV.interface, "all" );
   ufdbNewGV.portNum = UFDB_DAEMON_PORT;
   ufdbNewGV.nWorkers = UFDB_MIN_THREADS;
   ufdbNewGV.debugHttpd = 0;
   ufdbNewGV.logPass = 0;
   ufdbNewGV.logBlock = 0;
   ufdbNewGV.logAllRequests = 0;
   ufdbNewGV.YoutubeEdufilter = 0;
   ufdbFree( ufdbNewGV.YoutubeEdufilterID );
   ufdbNewGV.YoutubeEdufilterID = NULL;
   ufdbNewGV.allowGoogleHTTPSusingIP = 0;

   /* When a database is reloaded, these variables may NOT be reset since they are used during the reload !! */
   ufdbNewGV.URLlookupDelayDBreload = 0;
   ufdbNewGV.URLlookupResultDBreload = UFDB_ALLOW;
   ufdbNewGV.URLlookupResultFatalError = UFDB_ALLOW;
   strcpy( ufdbNewGV.loadingDatabaseRedirect, "http://cgibin.urlfilterdb.com/cgi-bin/URLblocked.cgi?"
                "category=loading-database" );
   ufdbNewGV.SquidVersion = ufdbStrdup( UFDB_DEFAULT_SQUID_VERSION );

   ufdbNewGV.showURLdetails = 0;
   ufdbNewGV.logURLdetails = 0;
   ufdbNewGV.uploadCrashReports = 1;
   ufdbNewGV.lookupReverseIP = 0;
   ufdbNewGV.useAlsoIPv6onWan = 1;
   ufdbNewGV.debugSkype = 0;
   ufdbNewGV.debugGtalk = 0;
   ufdbNewGV.debugYahooMsg = 0;
   ufdbNewGV.debugAim = 0;
   ufdbNewGV.debugFBchat = 0;
   ufdbNewGV.debugCitrixOnline = 0;
   ufdbNewGV.debugRegexp = 0;
   ufdbNewGV.debugExternalScripts = 0;
   ufdbNewGV.expressionOptimisation = 1;
   ufdbNewGV.refreshUserlistInterval = UFDB_DEFAULT_REFRESH_USERLIST;
   ufdbNewGV.refreshIPlistInterval = UFDB_DEFAULT_REFRESH_IPLIST;
   ufdbNewGV.refreshDomainlistInterval = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   ufdbNewGV.analyseUncategorisedURLs = 1;
   ufdbNewGV.logUncategorisedURLs = 0;
   ufdbNewGV.uploadStats = 1;
   ufdbNewGV.safeSearch = 1;
   ufdbNewGV.skipSafeCategory = 0;
   ufdbNewGV.stripDomainFromUsername = 0;
   ufdbNewGV.tunnelCheckMethod = UFDB_API_HTTPS_CHECK_OFF;
   ufdbNewGV.SquidUsesActiveBumping = 0;
   ufdbNewGV.httpsWithHostname = 0;
   ufdbNewGV.httpsOfficialCertificate = 0;
   ufdbNewGV.unknownProtocolOverHttps = 1;
   ufdbNewGV.httpsNoSSLv2 = 1;
   ufdbNewGV.httpsNoSSLv3 = 1;
   ufdbNewGV.httpdPort = 0;
   ufdbNewGV.dateOfCheckedDB[0] = '\0';
   strcpy( ufdbNewGV.httpdInterface, "all" );
   strcpy( ufdbNewGV.httpdImagesDirectory, "." );
 
   ufdbNewGV.databaseStatus = UFDB_API_STATUS_DATABASE_OK;

   (void) yyparse();		/* parse the configuration file ********************/
   fclose( yyin );

   ufdbNewGV.databaseLoadTime = time( NULL );

   /*
    * For analysis of uncategorised URLs we also load a "checked" category
    * that contains URLs that are reviewed and checked not to be part of
    * any other category.
    */
   char * dbhome;
   char   dbfname[1024];

   dbhome = ufdbNewGV.databaseDirectory;

   /* TODO: check if "checked" was not already loaded... */
   if (ufdbNewGV.analyseUncategorisedURLs > 0)
   {
      int status;
      sprintf( dbfname, "%s/checked/domains.ufdb", dbhome );
      status = UFDBloadDatabase( &ufdbNewGV, &ufdbNewGV.checkedDB, dbfname );
      if (status != UFDB_API_OK  &&  status != UFDB_API_STATUS_DATABASE_OLD)
      {
         ufdbNewGV.checkedDB.mem = NULL;
         ufdbNewGV.checkedDB.index = NULL;
         ufdbNewGV.checkedDB.table.nNextLevels = 0;
         if (ufdbGV.debug)
            ufdbLogMessage( "The URL database appears not be from URLfilterDB. No problem." );
      }
      else
      {
         if (ufdbGV.debug)
            ufdbLogMessage( "table \"checked\" is loaded: %s %8.8s",
                            ufdbNewGV.checkedDB.date, ufdbNewGV.checkedDB.flags );
         sprintf( dbfname, "%s/checked/expressions", dbhome );
         (void) UFDBloadExpressions( &ufdbNewGV.checkedExpressions, dbfname );
         ufdbLogMessage( "The implicitly allowed URL category 'checked' is loaded." );
      }
   }

   if (ufdbNewGV.defaultAcl == NULL)
      ufdbLogFatalError( "\"default\" ACL is not defined" );
   else if (ufdbNewGV.defaultAcl->pass == NULL)
      ufdbLogError( "\"default\" ACL is empty: by default all URLs are blocked." );

   /* A configuration file may have a source definition which is not used in the ACL list.
    * This raises the question "what to do with this ?".
    * If we do nothing, the source is matched but has no ACL definition and is silently skipped.
    * Most likely the administrator overlooked something so a warning is useful.
    */
   source = ufdbNewGV.sourceList;
   if (source == NULL  &&  ufdbNewGV.defaultAcl == NULL)
      ufdbLogFatalError( "There are no sources and there is no default ACL" );

   for ( ; source != NULL;  source = source->next)
   {
      int found;

      found = 0;
      for (acl = ufdbNewGV.aclList;  acl != NULL;  acl = acl->next)
      {
         if (strcmp( acl->name, source->name ) == 0)
	 {
	    found = 1;
	    break;
	 }
      }
      if (!found)
      {
         ufdbLogError( "source \"%s\" has no ACL.  *****\n"
	               "This most likely may lead to unexpected results when the source is matched.  *****\n"
		       "It is strongly suggested to remove the source definition OR add the source to the acl.  *****",
		       source->name );
	 source->active = 0;
      }
      else if (acl->pass == NULL)
      {
         ufdbLogMessage( "source \"%s\" has an empty \"pass\" in its ACL *****", source->name );
      }
   }

   for (cat = ufdbNewGV.catList;  cat != NULL;  cat = cat->next)
   {
      if (cat->options == 0  &&  cat->domainlist == NULL  &&  cat->execdomainlist == NULL  && 
          cat->expressionlist == NULL  &&  cat->rewrite == NULL  &&  cat->name != NULL)
      {
         ufdbLogError( "category \"%s\" has no content definition  *****", cat->name );
      }
   }

   if (ufdbNewGV.adminEmail != NULL  &&  ufdbNewGV.emailServer == NULL)
   {
      ufdbLogError( "No email server is defined; cannot send email to \"%s\"  *****", ufdbNewGV.adminEmail );
   }
   if (ufdbNewGV.adminEmail != NULL  &&  ufdbNewGV.emailServer != NULL  &&  ufdbNewGV.senderEmail == NULL)
   {
      ufdbLogMessage( "WARNING: No sender email address is defined; using \"%s\" as sender",
                      ufdbNewGV.adminEmail );
   }

   if (strncmp( ufdbNewGV.SquidVersion, "6.", 2 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "5.", 2 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "4.", 2 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.5", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.4", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.3", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.2", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.1", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.0", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "2.7", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "2.6", 3 ) != 0)
   {
      ufdbLogFatalError( "Unsupported Squid version \"%s\"  *****\n"
                         "The supported values for squid-version are: "
                         "6.x, 5.x, 4.x, 3.5, 3.4, 3.3, 3.2, 3.1, 3.0, 2.7, 2.6  *****\n"
			 "If the version of Squid is higher, it is recommended to upgrade ufdbGuard.  *****\n"
			 "Alternatively set squid-version to the highest supported version",
			 ufdbNewGV.SquidVersion );
   }
   if (strncmp( ufdbNewGV.SquidVersion, "6.", 2 ) == 0  ||
       strncmp( ufdbNewGV.SquidVersion, "5.", 2 ) == 0  ||
       strncmp( ufdbNewGV.SquidVersion, "4.", 2 ) == 0  ||  
       strncmp( ufdbNewGV.SquidVersion, "3.5", 3 ) == 0  ||  
       strncmp( ufdbNewGV.SquidVersion, "3.4", 3 ) == 0)
      ufdbNewGV.SquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL3;
   else if (strncmp( ufdbNewGV.SquidVersion, "2.6", 3 ) == 0  ||  
            strncmp( ufdbNewGV.SquidVersion, "2.7", 3 ) == 0)
      ufdbNewGV.SquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL1;
   else
      ufdbNewGV.SquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL2;	/* 3.0 - 3.3 */

   BuildImplicitPassLists( &ufdbNewGV );

   return 1;
}


static void setDBhome( char * dbhome )
{
   struct stat dirbuf;

   if (strlen(dbhome) > sizeof(ufdbNewGV.databaseDirectory)-1)
   {
      ufdbLogFatalError( "maximum length for dbhome is %d", (int) sizeof(ufdbNewGV.databaseDirectory)-1 );
      ufdbFree( dbhome );
      return;
   }
   strcpy( ufdbNewGV.databaseDirectory, dbhome );

   if (stat( dbhome, &dirbuf ) != 0)
   {
      ufdbLogFatalError( "dbhome %s: directory does not exist or access rights are insufficient", dbhome );
   }
   else
   {
      if (!S_ISDIR(dirbuf.st_mode))
         ufdbLogFatalError( "dbhome: %s is not a directory", dbhome );
   }

   ufdbFree( dbhome );
}


static void setAdministrator( char * value )
{
   char * p;

   if (strlen(value) > sizeof(ufdbNewGV.administrator)-1)
   {
      ufdbLogError( "maximum length for administrator is %d", (int) sizeof(ufdbNewGV.administrator)-1 );
      return;
   }

   while ((p = (char *) strchr( value, '?' )) != NULL)
      *p = '_';
   while ((p = (char *) strchr( value, '&' )) != NULL)
      *p = '_';

   strcpy( ufdbNewGV.administrator, value );
   ufdbFree( value );
}


static void setLogdir( char * value )
{
   strcpy( ufdbNewGV.logDirectory, value );

   ufdbSetGlobalErrorLogFile( ufdbNewGV.logDirectory, NULL, 0 );
}


static void setPidfile( char * value )
{
   if (ufdbNewGV.pidFilename != NULL)
      ufdbFree( ufdbNewGV.pidFilename );
   ufdbNewGV.pidFilename = value;
}


static void setRefreshUserlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshuserlist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_USERLIST );
      nmin = UFDB_DEFAULT_REFRESH_USERLIST;
   }
   ufdbNewGV.refreshUserlistInterval = nmin;
}


static void setRefreshIPlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshiplist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_IPLIST );
      nmin = UFDB_DEFAULT_REFRESH_IPLIST;
   }
   ufdbNewGV.refreshIPlistInterval = nmin;
}


static void setRefreshDomainlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshdomainlist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_DOMAINLIST );
      nmin = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   }
   ufdbNewGV.refreshDomainlistInterval = nmin;
}


/*
 * Source functions
 */

static void defSource( 
   char *          source )
{
   struct Source * sp;

   if (ufdbGV.debug)
      ufdbLogMessage( "defSource: defining source \"%s\"", source );

   if ((struct Source *) defSourceFindName(ufdbNewGV.sourceList,source) != NULL)
   {
      ufdbLogFatalError( "line %d: source %s is already defined in configuration file %s",
			 lineno, source, ufdbNewGV.configFile );
      ufdbFree( source );
      return;
   }

   sp = (struct Source *) ufdbMallocAligned( UFDB_CACHELINE_SIZE, sizeof(struct Source) );
   sp->name = source;
   sp->active = 1;
   sp->evaluationMethod = UFDB_EVAL_OR;
   sp->ipv4hosts = NULL;
   sp->ipv4 = NULL;
   sp->ipv6hosts = NULL;
   sp->ipv6 = NULL;
   sp->domainDb = NULL;
   sp->userDb = NULL;
   sp->time = NULL;
   sp->within = UFDB_ACL_NONE;
   sp->cont_search = 0;
   sp->sarg0 = NULL;
   sp->execiplistCommand = NULL;
   sp->next = NULL;
   sp->nblocks = 0;
   sp->nmatches = 0;

   if (ufdbNewGV.sourceList == NULL)
   {
      if (ufdbGV.debug)
         ufdbLogMessage( "defSource: SourceList is set to point to \"%s\"", source );
      ufdbNewGV.sourceList = sp;
      ufdbNewGV.lastSource = sp;
   }
   else
   {
      ufdbNewGV.lastSource->next = sp;
      ufdbNewGV.lastSource = sp;
   }
}


static void defSourceEnd( void )
{
   struct Source * s;

   s = ufdbNewGV.lastSource;
   if (s->ipv4 == NULL  &&  s->ipv4hosts == NULL  &&  
       s->ipv6 == NULL  &&  s->ipv6hosts == NULL  &&
       s->domainDb == NULL  &&  s->userDb == NULL)
   {
      if (s->execiplistCommand == NULL)
      {
	 ufdbLogError( "source \"%s\" missing active content, set inactive  *****", s->name );
	 s->time = NULL;
	 s->active = 0;
      }
      else
	 ufdbLogError( "source \"%s\" has an execiplist command but the list is empty and set inactive   *****",
	               s->name );
   }
}


static void ufdbSourceUser( 
   char *          user )
{
   char *          lc;
   struct Source * sp;

   sp = ufdbNewGV.lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "user \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         user, sp->name, lineno );
      return;
   }
   if (sp->userDb == NULL)
   {
      sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }

   for (lc = user;  *lc != '\0';  lc++)    // convert username to lowercase
   {
      if (*lc <= 'Z'  &&  *lc >= 'A')
         *lc += 'a' - 'A';
   }

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbSourceUser: adding user \"%s\"", user );

   sp->userDb->entries++;
   UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, NULL );
   ufdbFree( user );
}


static void ufdbSourceUnixGroup(
   char *          groupName  )
{
   struct Source * sp;
   struct group *  grp;
   int             n;
   char *          user;

   sp = ufdbNewGV.lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "unix group \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         groupName, sp->name, lineno );
      return;
   }
   if (sp->userDb == NULL) 
   {
      sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }
 
   n = 0;
   setgrent();
   errno = 0;
   grp = getgrnam( groupName );
   if (grp != NULL)
   {
      if (ufdbGV.debug > 1)
         ufdbLogMessage( "found group \"%s\"", grp->gr_name );

      while ((user = grp->gr_mem[n]) != NULL)
      {
	 char * lc;

	 if (ufdbGV.debug > 1)
	    ufdbLogMessage( "group \"%s\" has user \"%s\"", grp->gr_name, user );
	 for (lc = user;  *lc != '\0';  lc++)  	// convert username to lowercase
	 {
	    if (*lc <= 'Z'  &&  *lc >= 'A')
	       *lc += 'a' - 'A';
	 }
	 UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, NULL );
	 sp->userDb->entries++;
	 n++;
      }
      ufdbLogMessage( "source \"%s\": unix group \"%s\" has %d members", sp->name, groupName, n );
      if (n == 0)
	 ufdbLogMessage( "WARNING: source \"%s\": \"%s\" is an empty group  +++++", sp->name, groupName );
   }
   else
   {
      ufdbLogFatalError( "source \"%s\": \"%s\" is not a unix group", sp->name, groupName );
      if (errno)
	 ufdbLogError( "ufdbSourceUnixGroup: getgrnam returned error %d: %s", errno, strerror(errno) );
   }
   endgrent();
}


static void ufdbSourceGroup( 
   int    groupType,
   char * groupName  )
{
   switch (groupType)
   {
   case UFDB_GROUPTYPE_UNIX:
      ufdbSourceUnixGroup( groupName );
      break;
   default:     
      ufdbLogFatalError( "ufdbSourceGroup: unknown group type %d", groupType );
   }

   ufdbFree( groupName );
}


struct sgDb * UFDBretrieveExecDomainlist( struct Category * cat )       // uses ufdbGV
{
   char *        t;
   FILE *        fp;
   struct sgDb * newdb;
   int           exitcode;
   struct stat   Stat0;
   struct stat   Stat1;
   char          line[1024];
   char          basefilename[1024];
   char          fullfilename[1024];
   char          command[3000];

   if (cat == NULL)
   {
      ufdbLogFatalError( "UFDBretrieveExecDomainlist: category is NULL" );
      return NULL;
   }

   if (cat->domainlist == NULL)
   {
      ufdbLogError( "will not execute command for category %s since domainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->execdomainlist == NULL)
   {
      ufdbLogError( "can't execute command for category %s since execdomainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->domainlist[0] == '/')
   {
      strcpy( basefilename, cat->domainlist );
   }
   else
   {
      char * dbhome;
      dbhome = ufdbGV.databaseDirectory;
      sprintf( basefilename, "%s/%s", dbhome, cat->domainlist );
   }
   strcpy( fullfilename, basefilename );
   strcat( fullfilename, UFDBfileSuffix );

   if (stat( fullfilename, &Stat0 ) != 0)
   {
      Stat0.st_mtime = 0;
      ufdbLogMessage( "category %s: pre-execdomainlist: domainlist does not exist (%s)",
                      cat->name, fullfilename );
   }

   /* The script that we will call needs the directory where the files reside,
    * so the popen-command contains a "cd" just before executing the script.
    * (note that we are multithreaded and cannot use chdir() here)
    */
   strcpy( command, "cd " );
   strcat( command, basefilename );
   t = strrchr( command, '/' );
   if (t != NULL)
      *t = '\0';
   strcat( command, " ; " );
   strcat( command, cat->execdomainlist );

   errno = 0;
   if ((fp = popen(command,"r")) == NULL)
   {
      ufdbLogFatalError( "category %s: can't execute command of execdomainlist \"%s\": popen failed: %s  *****",
                         cat->name, cat->execdomainlist, strerror(errno) );
      return NULL;
   }

   while (UFDBfgetsNoNL(line,sizeof(line)-1,fp) != NULL)
   {
      ufdbLogMessage( "execdomainlist for %s produced: %s", cat->name, line );
   }
   errno = 0;
   exitcode = pclose( fp );

   if (exitcode == -1  &&  errno == ECHILD)
      exitcode = 0;
      /* most likely the child handler thread already did a wait() */

   if (exitcode == 0)
   {
      if (ufdbGV.debug || ufdbGV.debugExternalScripts)
         ufdbLogMessage( "   execdomainlist for %s: exit 0 (OK)", cat->name );
   }
   else if (exitcode == -1)
   {
      ufdbLogError( "execdomainlist for %s: pclose error: %d (%s)", cat->name, errno, strerror(errno) );
      return NULL;
   }
   else if (exitcode > 0)
   {
      ufdbLogError( "execdomainlist for %s: command (%s) terminated with an error exit code %d", 
                    cat->name, cat->execdomainlist, exitcode );
      return NULL;
   }

   /* The command defined by 'execdomainlist' has been executed and the exit code was 0 (OK), so
    * now it is verified if the file timestamp of domains.ufdb is newer.
    */

   if (stat( fullfilename, &Stat1 ) != 0)
   {
      ufdbLogError( "execdomainlist for %s: command failed to produce a .ufdb file (%s)",
                    cat->name, fullfilename );
      return NULL;
   }

   newdb = (struct sgDb *) ufdbCalloc( sizeof(struct sgDb), 1 );
   newdb->dbhome = NULL;
   newdb->dbcp = NULL;
   newdb->type = SGDBTYPE_DOMAINLIST;

   sgDbInit( newdb, basefilename );
   if (newdb->dbcp == NULL)
   {
      ufdbLogError( "execdomainlist for %s: command produced a .ufdb file but I failed to load it", cat->name );
      ufdbFree( newdb );
      return NULL;
   }

   if (ufdbGV.debug || ufdbGV.debugExternalScripts)
      ufdbLogMessage( "execdomainlist for %s: new URL table is loaded", cat->name );

   return newdb;
}


static void ufdbSourceExecUserList(
   char *          command )            // must be malloced
{
   time_t          t0, te;
   struct Source * sp;

   /* execuserlist is used to dynamically retrieve a list of usernames and
    * is executed every 15 minutes to refresh the list of usernames.
    */

   sp = ufdbNewGV.lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_EXECUSERLIST)
   {
      ufdbLogFatalError( "execuserlist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         command, sp->name, lineno );
      return;
   }
   if (sp->userDb != NULL)
   {
      ufdbLogFatalError( "execuserlist \"%s\" in source \"%s\" on line %d: "
                         "more than one execuserlist is not supported.  Merge the userlists in the script.", 
                         command, sp->name, lineno );
      return;
   }
   ufdbLogMessage( "execuserlist \"%s\"", command );

   t0 = time( NULL );
   sp->userDb = UFDBretrieveExecUserlist( &ufdbNewGV, command );
   sp->sarg0 = command;				/* command is already malloc-ed */
   te = time( NULL );

   if (te - t0 > 4)
      ufdbLogMessage( "WARNING: it took %ld seconds to execute \"%s\"  *****", (long) (te - t0), command );
 
   if (ufdbGV.debug>1 || ufdbGV.debugExternalScripts)
   {
      UFDBmemDBprintUserDB( "user", (struct UFDBmemDB *) sp->userDb->dbcp );
   }
}


static void ufdbSourceExecIPList(
   char *          command )            // must be malloced
{
   time_t          t0, te;
   struct Source * sp;

   /* execiplist is used to dynamically retrieve a list of IP addresses and
    * is executed every 15 minutes to refresh the list of IP addresses.
    */

   sp = ufdbNewGV.lastSource;
   if (sp->ipv4 != NULL  ||  sp->ipv6 != NULL)
   {
      ufdbLogFatalError( "execiplist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec iplists", 
                         command, sp->name, lineno );
      return;
   }
   ufdbLogMessage( "execiplist \"%s\"", command );

   t0 = time( NULL );
   UFDBretrieveExecIPlist( &ufdbNewGV, command, &sp->ipv4hosts, &sp->ipv4, &sp->ipv6hosts, &sp->ipv6 );
   sp->execiplistCommand = command;			/* command is already malloc-ed */
   te = time( NULL );

   if (te - t0 > 4)
      ufdbLogMessage( "WARNING: it took %ld seconds to execute \"%s\"  *****", (long) (te - t0), command );
 
   if (ufdbGV.debug>1 || ufdbGV.debugExternalScripts)
   {
      UFDBlogIPv4( sp->ipv4 );
      UFDBlogIPv6( sp->ipv6 );
   }
}


static void ufdbSourceUserList( 
   char * file  )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   char * s;
   char * lc;
   char * lineptr;
   int    ullineno;
   struct sgDb * udb;
   struct Source * sp;
   char   line[10000];
 
   sp = ufdbNewGV.lastSource;
   if (ufdbGV.debug)
      ufdbLogMessage( "ufdbSourceUserList: source \"%s\"  file \"%s\"", 
       		      sp->name != NULL ? sp->name : "nosource", file );
   udb = sp->userDb;
   if (udb != NULL  &&  udb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "userlist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         file, sp->name, lineno );
      return;
   }
   if (udb == NULL)
   {
      udb = sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      udb->dbhome = NULL;
      udb->dbcp = (void *) UFDBmemDBinit();
      udb->type = SGDBTYPE_USERLIST;
      udb->entries = 0;
   }
 
   dbhome = ufdbNewGV.databaseDirectory;
 
   if (file[0] == '/')
      f = file;
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }
 
   if ((fp = fopen(f,"r")) == NULL)
   {
      ufdbLogError( "line %d: can't open userlist %s: %s  *****", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }
   ullineno = 0;
 
   ufdbLogMessage( "userlist \"%s\"", f );
 
   while (fgets(line,sizeof(line),fp) != NULL)
   {
      ullineno++;
      if (line[0] == '#')			/* skip comments */
         continue;
 
      p = strchr( line, '\n' );
      if (p != NULL)
      {
         *p = '\0';
         if (p != line) 
         {
  	    if (*(p - 1) == '\r') 		/* remove ^M  */
  	       *(p-1) = '\0';
         }
      }
  
      if (line[0] == '\0')
      {
         ufdbLogError( "userlist %s: line %d: line is empty", f, ullineno );
         continue;
      }
  
      c = strchr( line, '#' );		        /* remove comment */
      if (c != NULL)
         *c = '\0';
  
      p = strtok_r( line, " \t,", &lineptr );
      if (p == NULL  ||  *p == '\0')
         continue;
  
      /* we may have a passwd-style formatted file. Ignore ':' and everything else that follows. */
      if ((s = strchr(p,':')) != NULL) 
         *s = '\0';
  
      do
      {
         for (lc = p;  *lc != '\0';  lc++)      // convert username to lowercase
         {
  	    if (*lc <= 'Z'  &&  *lc >= 'A')
  	       *lc += 'a' - 'A';
         }
         if (*p != '\0')
 	 {
	    udb->entries++;
  	    UFDBmemDBinsert( (struct UFDBmemDB *) udb->dbcp, p, NULL );
         }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL  &&  *p != '\0');
   }
   fclose( fp );

   if (ufdbGV.debug > 1)
   {
      ufdbLogMessage( "just read userlist \"%s\"", f );
      UFDBmemDBprintUserDB( "user", (struct UFDBmemDB *) udb->dbcp );
   }

   ufdbFree( f );
}


static void ufdbSourceUserQuota( 
   const char * seconds, 
   const char * sporadic,  
   const char * renew )
{
   if (seconds == NULL || sporadic == NULL || renew == NULL)
      { ; }      // prevent compiler warning

   ufdbLogError( "line %d: userquota is not supported", lineno );
}


static void defSourceDomain( 
   char * domain )
{
   struct Source * sp;

   sp = ufdbNewGV.lastSource;
   if (sp->domainDb == NULL) 
      sp->domainDb = (struct sgDb *) UFDBmemDBinit();

   if (ufdbGV.debug)
      ufdbLogMessage( "defSourceDomain \"%s\"", domain );

   UFDBmemDBinsert( (struct UFDBmemDB *) sp->domainDb, domain, NULL );

   ufdbFree( domain );
}


static void ufdbSourceEval( 
   int method  )
{
   if (ufdbNewGV.lastSource != NULL)
   {
      if (ufdbGV.debug)
         ufdbLogMessage( "ufdbSourceEval %d: %s", method, 
	                 method == UFDB_EVAL_OR ? "evaluate-or" : "evaluate-and" );
      ufdbNewGV.lastSource->evaluationMethod = method;
   }
}


static void defSourceTime( 
   char *         name, 
   int            within )
{
   struct ufdbTime *  t;

   if ((t = sgTimeFindName(name)) == NULL)
   {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, ufdbNewGV.configFile );
      ufdbFree( name );
      return;
   }

   ufdbNewGV.lastSource->within = within;
   ufdbNewGV.lastSource->time = t;
   ufdbFree( name );
}


static struct Source * defSourceFindName( 
   struct Source * slist,
   const char *    name )
{
   for ( ;  slist != NULL;  slist = slist->next)
   {
      if (strcmp(name,slist->name) == 0)
         return slist;
   }
   return NULL;
}


static void defSourceIPV4List( 
   char * file )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   char * cidr;
   int    i;
   int    l = 0;
   char * lineptr;
   char   line[UFDB_MAX_URL_LENGTH];

   dbhome = ufdbNewGV.databaseDirectory;

   if (file[0] == '/') 
   {
      f = file;
   }
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }

   if ((fp = fopen(f,"r")) == NULL) 
   {
      ufdbLogError( "line %d: can't open ipv4list %s: %s", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }

   ufdbLogMessage( "ipv4list \"%s\"", f );

   while (fgets(line,sizeof(line),fp) != NULL)
   {
      l++;
      if (*line == '#')
         continue;
      p = strchr( line, '\n' );
      if (p != NULL && p != line) 
      {
         if (*(p - 1) == '\r') 		        // remove ^M
            p--;
         *p = '\0';
      }
      c = strchr( line, '#' );
      p = strtok_r( line, " \t,", &lineptr );
      do {
         if (c != NULL && p >= c) 		// find the comment
            break;
         i = strspn( p, ".0123456789/-" );
         if (i == 0)
            break;
         *(p + i) = '\0';
         if ((cidr = strchr(p,'/')) != NULL) 
         {
            if (strchr(cidr,'.') == NULL)
               sgIpv4( p, SG_IPTYPE_CIDR, f, l );
            else 
               sgIpv4( p, SG_IPTYPE_CLASS, f, l );
          }
          else if ((cidr = strchr(p,'-')) != NULL) 
          {
             sgIpv4( p, SG_IPTYPE_RANGE, f, l );
          }
          else
          {
             sgIpv4( p, SG_IPTYPE_HOST, f, l );
          }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
   }

   fclose( fp );
   ufdbFree( f );
}


static void defSourceIPV6List( 
   char * file )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   int    i;
   int    l = 0;
   char * lineptr;
   char   line[UFDB_MAX_URL_LENGTH];

   dbhome = ufdbNewGV.databaseDirectory;

   if (file[0] == '/') 
   {
      f = file;
   }
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }

   if ((fp = fopen(f,"r")) == NULL) 
   {
      ufdbLogError( "line %d: can't open ipv6list %s: %s", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }

   ufdbLogMessage( "ipv6list \"%s\"", f );

   while (fgets(line,sizeof(line),fp) != NULL)
   {
      l++;
      if (*line == '#')
         continue;
      p = strchr( line, '\n' );
      if (p != NULL && p != line) 
      {
         if (*(p - 1) == '\r') 		        // remove ^M
            p--;
         *p = '\0';
      }
      c = strchr( line, '#' );
      p = strtok_r( line, " \t,", &lineptr );
      do {
         if (c != NULL && p >= c) 		// find the comment
            break;
         i = strspn( p, ":.0123456789ABCDEFabcdef/" );
         if (i == 0)
            break;
         *(p + i) = '\0';
         if (strchr(p,'/') != NULL) 
         {
            sgIpv6( p, SG_IPV6TYPE_CIDR, f, l );
         }
         else
         {
            sgIpv6( p, SG_IPV6TYPE_HOST, f, l );
         }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
   }

   fclose( fp );
   ufdbFree( f );
}


/* category block functions */

void ufdbCategory( 
  char *            cat )
{
  struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategory %s", cat );
#endif

  if (ufdbNewGV.catList != NULL) 
  {
    if ((struct Category *) ufdbCategoryFindByName(&ufdbNewGV,cat) != NULL)
    {
      ufdbLogFatalError( "line %d: category %s is already defined in configuration file %s",
		         lineno, cat, ufdbNewGV.configFile );
      ufdbFree( cat );
      return;
    }
  }

  sp = (struct Category *) ufdbMallocAligned( UFDB_CACHELINE_SIZE, sizeof(struct Category) );
  sp->active = 1;
  sp->within = UFDB_ACL_NONE;
  sp->activeBumping = UFDB_ACTIVE_BUMPING_NOTSET;
  sp->blockBumpedConnect = 0;
  sp->options = 0;
  sp->name = cat;
  sp->domainlist = NULL;
  sp->domainlistDb = NULL;
  sp->execdomainlist = NULL;
  sp->expressionlist = NULL;
  sp->regExp = NULL;
  sp->redirect = NULL;
  sp->time = NULL;
  sp->rewrite = NULL;
  sp->next = NULL;
  sp->nblocks = 0;
  sp->nmatches = 0;

  if (ufdbNewGV.catList == NULL) {
    ufdbNewGV.catList = sp;
    ufdbNewGV.lastCat = sp;
  } else {
    ufdbNewGV.lastCat->next = sp;
    ufdbNewGV.lastCat = sp;
  }

   /* category "security" is a special case: the options cannot be set default to 0
    * because the default value for allow-unknown-protocol-over-https is ON.
    */
   if (strcmp( cat, "security" ) == 0)
      sp->options = UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS;
}


void ufdbCategoryEnd( void )
{
  struct Category * d;
 
  d = ufdbNewGV.lastCat;
  if (d->domainlist == NULL  &&  d->expressionlist == NULL  && 
      d->redirect == NULL  &&  d->rewrite == NULL  &&
      d->options == 0)
  {
    ufdbLogError( "category \"%s\" is missing content, set inactive  *****", d->name );
    d->time = NULL;
    d->active = 0;
  }
}


static void ufdbCategoryOption( int value, int option )
{
   struct Category * sp;

   sp = ufdbNewGV.lastCat;
   if (value)
      sp->options = sp->options | option;
   else
      sp->options = sp->options & (~option);

   if (option == UFDB_OPT_HTTPS_WITH_HOSTNAME)
      ufdbNewGV.httpsWithHostname = value;
   else if (option == UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE)
      ufdbNewGV.httpsOfficialCertificate = value;
   else if (option == UFDB_OPT_SKYPE_OVER_HTTPS)
      ufdbNewGV.SkypeOverHttps = value;
   else if (option == UFDB_OPT_GTALK_OVER_HTTPS)
      ufdbNewGV.GtalkOverHttps = value;
   else if (option == UFDB_OPT_YAHOOMSG_OVER_HTTPS)
      ufdbNewGV.YahooMsgOverHttps = value;
   else if (option == UFDB_OPT_AIM_OVER_HTTPS)
      ufdbNewGV.AimOverHttps = value;
   else if (option == UFDB_OPT_FBCHAT_OVER_HTTPS)
      ufdbNewGV.FBchatOverHttps = value;
   else if (option == UFDB_OPT_CITRIXONLINE_OVER_HTTPS)
      ufdbNewGV.CitrixOnlineOverHttps = value;
   else if (option == UFDB_OPT_ANYDESK_OVER_HTTPS)
      ufdbNewGV.AnydeskOverHttps = value;
   else if (option == UFDB_OPT_TEAMVIEWER_OVER_HTTPS)
      ufdbNewGV.TeamviewerOverHttps = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV2)
      ufdbNewGV.httpsNoSSLv2 = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV3)
      ufdbNewGV.httpsNoSSLv3 = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_TLSV1_0)
      ufdbNewGV.httpsNoTLSv1_0 = value;
   else if (option == UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS)
      ufdbNewGV.unknownProtocolOverHttps = value;
   else if (option == UFDB_OPT_SAFE_SEARCH)
      ;
   else if (option == UFDB_OPT_YOUTUBE_EDUFILTER)
      ;
   else
      ufdbLogError( "ufdbCategoryOption: unrecognised option %d *****", option );

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbCategoryOption: %s: option %d set to %d", sp->name, option, value );
}


void ufdbCategoryDomainList( 
  char * domainlist )
{
  struct Category * sp;
  const char *      dbhome;
        char *      dl;
  const char *      name;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "ufdbCategoryDomainList %s", domainlist==NULL ? "NULL" : domainlist );

  if (ufdbNewGV.terminating)
     return;

  sp = ufdbNewGV.lastCat;

  if (sp->domainlistDb != NULL)
  {
     ufdbLogFatalError( "line %d: specify only one domainlist per category in configuration file %s",
		        lineno, ufdbNewGV.configFile );
     return;
  }

  dbhome = ufdbNewGV.databaseDirectory;

  if (domainlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/domainlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/domainlist");

    sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->domainlist,dbhome);
    strcat(sp->domainlist,"/");
    strcat(sp->domainlist,dl);
  }
  else
  {
    if (domainlist[0] == '/') 
      sp->domainlist = domainlist;
    else
    {
       sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(domainlist) + 2 );
       strcpy( sp->domainlist, dbhome );
       strcat( sp->domainlist, "/" );
       strcat( sp->domainlist, domainlist );
       ufdbFree( (void*) domainlist );
    }
  }

  sp->domainlistDb = (struct sgDb *) ufdbCalloc( 1, sizeof(struct sgDb) );
  sp->domainlistDb->type = SGDBTYPE_DOMAINLIST;
  ufdbLogMessage( "loading URL table from \"%s\"", sp->domainlist );
  sgDbInit( sp->domainlistDb, sp->domainlist );
  if (sp->domainlistDb->dbcp == NULL  ||
      ((struct UFDBmemTable *) sp->domainlistDb->dbcp)->table.nNextLevels == 0)
  {
    ufdbLogError( "URL database table \"%s\" is empty and is ignored   *****", sp->domainlist );
    ufdbFreeDomainDb( sp->domainlistDb );
    sp->domainlistDb = NULL;
  }
}


static void ufdbCategoryExecDomainList( 
   char * command )
{
   struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryExecDomainList %s", command );
#endif

   sp = ufdbNewGV.lastCat;

   if (sp == NULL)
   {
      ufdbLogFatalError( "execdomainlist is not within a URL category" );
      return;
   }
   sp->execdomainlist = command;

   if (ufdbGV.debug)
      ufdbLogMessage( "execdomainlist for category %s: \"%s\"", sp->name, command );
}


void ufdbFreeDomainDb( 
   struct sgDb * dbp )
{
   struct UFDBmemTable * mt;

   if (dbp == NULL)
      return;

   mt = (struct UFDBmemTable *) dbp->dbcp;
   if (mt != NULL)
   {
      if (mt->index != NULL)
      {
	 ufdbFree( mt->index );				/* version 2.x */
	 ufdbFree( mt->table.nextLevel );
      }
      else
	 UFDBfreeTableIndex_1_2( &(mt->table) ); 	/* version 1.2 */
#if HAVE_MADVISE && !UFDB_BARE_METAL_SUPPORT && __linux__
      if (mt->madvisedSize)
         madvise( mt->mem, mt->madvisedSize, MADV_NORMAL );
#endif
      if (mt->memStatus == UFDB_MEMSTATUS_MALLOC)
         ufdbFree( (void *) mt->mem );
      ufdbFree( mt );
   }
   ufdbFree( dbp );
}


void ufdbFreeIpv4List( struct Ipv4 * ipv4 )
{
   struct Ipv4 * tmp;

   while (ipv4 != NULL)
   {
      tmp = ipv4->next;
      ufdbFree( (void*) ipv4 );
      ipv4 = tmp;
   }
}


void ufdbFreeIpv6List( struct Ipv6 * ipv6 )
{
   struct Ipv6 * tmp;

   while (ipv6 != NULL)
   {
      tmp = ipv6->next;
      ufdbFree( (void*) ipv6 );
      ipv6 = tmp;
   }
}


static void ufdbFreeSourceList( struct Source * src )
{
   struct Source * tmp;

   while (src != NULL)
   {
      if (src->ipv4hosts != NULL)
         UFDBmemDBdeleteDB( src->ipv4hosts );
      ufdbFreeIpv4List( src->ipv4 );
      if (src->ipv6hosts != NULL)
         UFDBmemDBdeleteDB( src->ipv6hosts );
      ufdbFreeIpv6List( src->ipv6 );

      ufdbFree( (void*) src->name );
      if (src->domainDb != NULL)
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) src->domainDb );

      /* execuserlist content is saved during a reload except when ufdbguardd terminates */
      if (src->userDb != NULL  &&  src->userDb->type != SGDBTYPE_EXECUSERLIST)
      {
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) src->userDb->dbcp );
	 ufdbFree( (void*) src->userDb );
      }
      ufdbFree( (void*) src->sarg0 );
      ufdbFree( (void*) src->execiplistCommand );

      tmp = src->next;
      ufdbFree( (void*) src );
      src = tmp;
   }
}


static void ufdbFreeAclCategoryList( struct AclCategory * ac )
{
   struct AclCategory * tmp;

   while (ac != NULL)
   {
      ufdbFree( (void*) ac->name );
      tmp = ac->next;
      ufdbFree( (void*) ac );
      ac = tmp;
   }
}


static void ufdbFreeAclList( struct Acl * acl )
{
   struct Acl * tmp;

   while (acl != NULL)
   {
      ufdbFree( (void*) acl->name );
      ufdbFreeAclCategoryList( acl->pass );
      ufdbFreeAclCategoryList( acl->implicitPass );
      ufdbFree( (void*) acl->redirect );
      tmp = acl->next;
      ufdbFree( (void*) acl );
      acl = tmp;
   }
}


static void ufdbFreeCategoryList( struct Category * cat )
{
   struct Category * tmp;

   while (cat != NULL)
   {
      if (ufdbGV.debug > 1  ||  ufdbGV.debugRegexp)
         ufdbLogMessage( "ufdbFreeCategoryList: freeing regexp of category %s", cat->name );
      ufdbFreeRegExprList( cat->regExp );
      ufdbFree( (void*) cat->name );
      ufdbFree( (void*) cat->domainlist );
      ufdbFreeDomainDb( cat->domainlistDb );
      ufdbFree( (void*) cat->execdomainlist );
      ufdbFree( (void*) cat->expressionlist );
      ufdbFree( (void*) cat->redirect );
      /* ufdbFree( cat->rewrite );  freed in ufdbFreeRewriteList() */
      tmp = cat->next;
      ufdbFree( (void*) cat );
      cat = tmp;
   }
}


static void ufdbFreeRewriteList( 
   struct sgRewrite * p )
{
   struct sgRewrite * tmp;

   while (p != NULL)
   {
      ufdbFreeRegExprList( p->rewrite );
      ufdbFree( (void*) p->name );
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


static void ufdbFreeTimeElement( 
   struct TimeElement * p )
{
   struct TimeElement * tmp;

   while (p != NULL)
   {
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


static void ufdbFreeTime( 
   struct ufdbTime * p )
{
   struct ufdbTime * tmp;

   while (p != NULL)
   {
      ufdbFree( (void*) p->name );
      ufdbFreeTimeElement( p->element );
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


void ufdbFreeLastBits( struct ufdbGV * gv )
{
   /* we may need these variables during a reload */
   if (gv->pidFilename != NULL)
   {
      ufdbFree( (void*) gv->pidFilename );
      gv->pidFilename = NULL;
   }
   if (gv->emailServer != NULL)
   {
      ufdbFree( (void*) gv->emailServer );
      gv->emailServer = NULL;
   }
   if (gv->myHostname != NULL)
   {
      ufdbFree( (void*) gv->myHostname );
      gv->myHostname = NULL;
   }
   if (gv->adminEmail != NULL)
   {
      ufdbFree( (void*) gv->adminEmail );
      gv->adminEmail = NULL;
   }
   if (gv->senderEmail != NULL)
   {
      ufdbFree( (void*) gv->senderEmail );
      gv->senderEmail = NULL;
   }
   if (gv->externalStatusCommand != NULL)
   {
      ufdbFree( (void*) gv->externalStatusCommand );
      gv->externalStatusCommand = NULL;
   }
}


void ufdbFreeAllMemory( struct ufdbGV * gv )
{
   gv->logDirectory[0] = '\0';

   ufdbFreeRewriteList( gv->rewrite );
   gv->rewrite = NULL;
   gv->lastRewrite = NULL;
   gv->lastRewriteRegExec = NULL;

   ufdbFreeCategoryList( gv->catList );
   gv->catList = NULL;
   gv->lastCat = NULL;

   ufdbFreeAclList( gv->aclList );
   gv->aclList = NULL;
   gv->lastAcl = NULL;
   gv->defaultAcl = NULL;
   gv->lastAclCategory = NULL;

   ufdbFreeSourceList( (struct Source *) gv->sourceList );
   gv->sourceList = NULL;
   gv->lastSource = NULL;

   /* free ufdbNewGV.checkedDB */
   if (gv->checkedDB.mem != NULL)
   {
      if (gv->checkedDB.index != NULL)
      {
         ufdbFree( (void*) gv->checkedDB.index );
	 ufdbFree( gv->checkedDB.table.nextLevel );
      }
      else
	 UFDBfreeTableIndex_1_2( &(gv->checkedDB.table) );
#if HAVE_MADVISE && !UFDB_BARE_METAL_SUPPORT && __linux__
      if (gv->checkedDB.madvisedSize)
         madvise( gv->checkedDB.mem, gv->checkedDB.madvisedSize, MADV_NORMAL );
#endif
      gv->checkedDB.madvisedSize = 0;
      if (gv->checkedDB.memStatus == UFDB_MEMSTATUS_MALLOC)
         ufdbFree( (void*) gv->checkedDB.mem );
   }
   gv->checkedDB.table.nextLevel = NULL;
   gv->checkedDB.table.nNextLevels = 0;
   gv->checkedDB.mem = NULL;
   gv->checkedDB.index = NULL;

   if (gv->checkedExpressions != NULL)
   {
      ufdbFreeRegExprList( gv->checkedExpressions );
      gv->checkedExpressions = NULL;
   }

   ufdbFreeTime( gv->timeList );
   gv->timeList = NULL;
   gv->lastTime = NULL;

   gv->lastTimeElement = NULL;
   gv->timeElement = NULL;

   gv->lastRegExpDest = NULL;

   ufdbFree( (void*) gv->SquidVersion );
   gv->SquidVersion = NULL;
}


static void ufdbCategoryUrlList( 
   char * urllist )
{
   if (urllist == NULL)
      urllist = (char *) "-";
   ufdbLogError( "line %d: \"urllist %s\" is deprecated and ignored *****\n"
                 "ufdbGenTable should be called with the -u option to include URLs\n"
		 "ufdbGenTable combines URLs and domains in one table file so only the domainlist is required",
		 lineno, urllist );
   if (urllist[0] != '-')
      ufdbFree( (void*) urllist );
}


void ufdbCategoryExpressionList( 
  char * exprlist, 
  const char * chcase  )
{
  FILE * fp;
  char * dbhome;
  char * dl;
  const char * name;
  char * p;
  int    flags;
  struct stat         statbuf;
  struct Category *   sp;
  struct ufdbRegExp * regexp;
  char   buf[UFDB_MAX_URL_LENGTH];
  char   errbuf[256];

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryExpressionList %s", exprlist );
#endif

  flags = REG_EXTENDED | REG_NOSUB;
  sp = ufdbNewGV.lastCat;
  dbhome = ufdbNewGV.databaseDirectory;

  if (exprlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/expressionlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/expressionlist");

    flags |= REG_ICASE; 	/* default case insensitive */

    sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->expressionlist,dbhome);
    strcat(sp->expressionlist,"/");
    strcat(sp->expressionlist,dl);
  }
  else
  {
    if (exprlist[0] == '/') 
    {
      sp->expressionlist = exprlist;
    }
    else
    {
       sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(exprlist) + 2 );
       strcpy( sp->expressionlist, dbhome );
       strcat( sp->expressionlist, "/" );
       strcat( sp->expressionlist, exprlist );
       ufdbFree( (void*) exprlist );
    }
    if (*chcase == 'i')
       flags |= REG_ICASE;     /* set case insensitive */
  }

  ufdbLogMessage( "loading regular expressions from \"%s\"", sp->expressionlist );

  if ((fp = fopen(sp->expressionlist, "r")) == NULL) 
  {
    ufdbLogFatalError( "cannot open expression list %s: %s", sp->expressionlist, strerror(errno) );
    return;
  }

  if (0 == fstat( fileno(fp), &statbuf ))
  {
     if (!S_ISREG(statbuf.st_mode))
     {
        ufdbLogFatalError( "expression list %s: not a regular file", sp->expressionlist );
	fclose( fp );
	return;
     }
  }

  while (!feof(fp)  &&  fgets(buf, sizeof(buf), fp) != NULL) 
  {
    if (buf[0] == '#')
       continue;

    p = (char *) strchr( buf, '\n' );
    if (p != NULL  &&  p != buf) 
    {
      if (*(p-1) == '\r') 	/* removing ^M  */
	p--;
      *p = '\0';
    }
    /* TO-DO: warn about leading and trailing spaces */
    regexp = ufdbNewPatternBuffer( buf, flags );
    if (regexp->error) 
    {
      regerror( regexp->error, (regex_t*) regexp->compiled[0], errbuf, sizeof(errbuf) );
      ufdbLogError( "regular expression error in %s:\n%s : %s   *****", sp->expressionlist, errbuf, buf );
    }
    if (ufdbNewGV.lastCat->regExp == NULL) 
    {
      ufdbNewGV.lastCat->regExp = regexp;
      ufdbNewGV.lastRegExpDest = regexp;
    }
    else
    {
      ufdbNewGV.lastRegExpDest->next = regexp;
      ufdbNewGV.lastRegExpDest = regexp;
    }
  }
  fclose( fp );

  if (ufdbNewGV.expressionOptimisation)
     ufdbNewGV.lastCat->regExp = UFDBoptimizeExprList( sp->expressionlist, ufdbNewGV.lastCat->regExp );
}


static void ufdbCategoryCACertsFile(
   char *              cacertsFile )
{
   struct Category *   cat;

   cat = ufdbNewGV.lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts can only be defined inside the \"security\" category" );
      return;
   }

   if (*cacertsFile == '/')
      strcpy( ufdbNewGV.CAcertsFile, cacertsFile );
   else
   {
      char * dbh;
      dbh = ufdbNewGV.databaseDirectory;
      strcpy( ufdbNewGV.CAcertsFile, dbh );
      strcat( ufdbNewGV.CAcertsFile, "/" );
      strcat( ufdbNewGV.CAcertsFile, cacertsFile );
   }
}


static void ufdbCategoryCACertsDir(
   char *              cacertsDir )
{
   struct Category *   cat;

   cat = ufdbNewGV.lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts-dir can only be defined inside the \"security\" category" );
      return;
   }

   if (*cacertsDir == '/')
      strcpy( ufdbNewGV.CAcertsDir, cacertsDir );
   else
   {
      char * dbh;
      dbh = ufdbNewGV.databaseDirectory;
      strcpy( ufdbNewGV.CAcertsDir, dbh );
      strcat( ufdbNewGV.CAcertsDir, "/" );
      strcat( ufdbNewGV.CAcertsDir, cacertsDir );
   }
}


static void ufdbCategoryRedirect( 
   char * value )
{
   struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryRedirect %s", value );
#endif

   sp = ufdbNewGV.lastCat;
   sp->redirect = value;
   /* TODO: check that "localhost" is not here if no 302 is used */
}


static void ufdbCategoryRewrite( 
  char *              value )
{
  struct sgRewrite *  rewrite;

  if ((rewrite = sgRewriteFindName(value)) == NULL)
  {
    ufdbLogFatalError( "line %d: rewrite %s is not defined in configuration file %s",
		       lineno, value, ufdbNewGV.configFile );
    return;
  }

  ufdbNewGV.lastCat->rewrite = rewrite;
}


static void ufdbCategoryBlockConnect( 
   int flag  )
{
   ufdbNewGV.lastCat->blockBumpedConnect = flag;

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbCategoryBlockConnect: category \"%s\" : block-bumped-connect %s",
                      ufdbNewGV.lastCat->name, flag ? "on" : "off" );
}


static void ufdbCategoryActiveBumping( 
   int flag  )
{
   ufdbNewGV.lastCat->activeBumping = flag ? UFDB_ACTIVE_BUMPING_ON : UFDB_ACTIVE_BUMPING_OFF;

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbCategoryActiveBumping: category \"%s\" : squid-uses-active-bumping %s",
                      ufdbNewGV.lastCat->name, flag ? "on" : "off" );
}


static void ufdbCategoryTime(  
   char *       name, 
   int  	within )
{
   struct ufdbTime * t;

   if ((t = sgTimeFindName(name)) == NULL) 
   {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
   		         lineno, name, ufdbNewGV.configFile );
      ufdbFree( (void*) name );
      return;
   }

   ufdbNewGV.lastCat->within = within;
   ufdbNewGV.lastCat->time = t;
   ufdbFree( (void*) name );
}


struct Category * ufdbCategoryFindByName( 
   struct ufdbGV *   gv,
   const char *      name )
{
   struct Category * p;

   for (p = gv->catList;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }
   return NULL;
}


static void sgRewrite( 
  char * rewrite )
{
  struct sgRewrite * rew;

#if UFDB_DEBUG
   ufdbLogMessage( "sgRewrite %s", rewrite );
#endif

  if (ufdbNewGV.rewrite != NULL)
  {
    if ((struct sgRewrite *) sgRewriteFindName(rewrite) != NULL)
    {
      ufdbLogFatalError( "line %d: rewrite \"%s\" is not defined in configuration file %s",
		         lineno, rewrite, ufdbNewGV.configFile );
      ufdbFree( (void*) rewrite );
      return;
    }
  }

  rew = (struct sgRewrite *) ufdbMalloc( sizeof(struct sgRewrite) );
  rew->name = rewrite;
  rew->active = 1;
  rew->rewrite = NULL;
  rew->time = NULL;
  rew->within = UFDB_ACL_NONE;
  rew->next = NULL;

  if (ufdbNewGV.rewrite == NULL) 
  {
    ufdbNewGV.rewrite = rew;
    ufdbNewGV.lastRewrite = rew;
  }
  else
  {
    ufdbNewGV.lastRewrite->next = rew;
    ufdbNewGV.lastRewrite = rew;
  }
}


static void sgRewriteTime( 
  char * name, 
  int    within )
{
  struct ufdbTime * t;

#if UFDB_DEBUG
   ufdbLogMessage( "sgRewriteTime %s %d", name, within );
#endif

  if ((t = sgTimeFindName(name)) == NULL)
  {
    ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		       lineno, name, ufdbNewGV.configFile );
    ufdbFree( (void*) name );
    return;
  }

  ufdbNewGV.lastRewrite->within = within;
  ufdbNewGV.lastRewrite->time = t;
  ufdbFree( (void*) name );
}


static void sgRewriteSubstitute( 
  char * string )
{
  char * pattern; 
  char * subst = NULL;
  char * p;
  int    flags = REG_EXTENDED;
  int    global = 0;
  char * httpcode = NULL;
  struct ufdbRegExp * regexp;
  char   errbuf[256];

  pattern = string + 2; 	/* skipping s@ */
  p = pattern;
  while ((p = strchr(p,'@')) != NULL)
  {
    if (*(p - 1) != '\\') 
    {
      *p = '\0';
      subst = p + 1;
      break;
    }
    p++;
  }

  p = strrchr( subst, '@' );
  while (p != NULL  &&  *p != '\0')
  {
    if (*p == 'r' )
      httpcode =  (char *) REDIRECT_TEMPORARILY;
    if (*p == 'R' )
      httpcode =  (char *) REDIRECT_PERMANENT;
    if (*p == 'i' || *p == 'I')
      flags |= REG_ICASE;
    if (*p == 'g')
      global = 1;
    *p = '\0'; 		/* removes @i from string */
    p++;
  } 

  regexp = ufdbNewPatternBuffer( pattern, flags );
  if (regexp->error) 
  {
      regerror( regexp->error, (regex_t*) regexp->compiled[0], errbuf, sizeof(errbuf) );
      ufdbLogError( "line %d: regular expression error in %s:\n%s   *****", lineno, pattern, errbuf );
  }
  else {
    regexp->substitute = ufdbStrdup( subst );
  }

  if (ufdbNewGV.lastRewrite->rewrite == NULL)
    ufdbNewGV.lastRewrite->rewrite = regexp;
  else 
    ufdbNewGV.lastRewriteRegExec->next = regexp;
  regexp->httpcode = httpcode;
  regexp->global = global;
  ufdbNewGV.lastRewriteRegExec = regexp;
}


static struct sgRewrite * sgRewriteFindName( 
   const char * name )
{
   struct sgRewrite * p;

   for (p = ufdbNewGV.rewrite;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }
   return NULL;
}


/*
 * Time functions
 */

/*
 * sgTime - parse configuration time statement.
 */
static void sgTime( 
  char *        name )
{
  struct ufdbTime * t;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "sgTime %s", name );

  if (ufdbNewGV.timeList != NULL)
  {
    if ((struct ufdbTime *) sgTimeFindName(name) != NULL)
    {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, ufdbNewGV.configFile );
      ufdbFree( (void*) name );
      return;
    }
  }
  else 
    numTimeElements = 0;

  t = (struct ufdbTime *) ufdbMalloc( sizeof(struct ufdbTime) );
  t->name = name;
  t->active = 1;
  t->element = NULL;
  t->next = NULL;

  ufdbNewGV.timeElement = NULL;
  ufdbNewGV.lastTimeElement = NULL;
  if (ufdbNewGV.timeList == NULL) 
  {
    ufdbNewGV.timeList = t;
    ufdbNewGV.lastTime = t;
  }
  else
  {
    ufdbNewGV.lastTime->next = t;
    ufdbNewGV.lastTime = t;
  }
}


/*
 * sgTimeElementInit - initialise parsing of a configuration time element.
 */
static void sgTimeElementInit( void )
{
   struct TimeElement * te;

   te = (struct TimeElement *) ufdbCalloc( 1, sizeof(struct TimeElement) );
   numTimeElements++;

   if (ufdbNewGV.lastTime->element == NULL)
     ufdbNewGV.lastTime->element = te;
   if (ufdbNewGV.lastTimeElement != NULL)
     ufdbNewGV.lastTimeElement->next = te;
   ufdbNewGV.lastTimeElement = te;
}


/*
 * sgTimeElementEnd - finalise parsing of configuration time element.
 */
static void sgTimeElementEnd( void )
{
  time_switch = 0;
  date_switch = 0;

  if (ufdbNewGV.lastTimeElement->fromdate != 0)
  {
    if (ufdbNewGV.lastTimeElement->todate == 0)
      ufdbNewGV.lastTimeElement->todate = ufdbNewGV.lastTimeElement->fromdate + 86399;
    else 
      ufdbNewGV.lastTimeElement->todate = ufdbNewGV.lastTimeElement->todate + 86399;
  }

  if (ufdbNewGV.lastTimeElement->from == 0  &&  ufdbNewGV.lastTimeElement->to == 0)
    ufdbNewGV.lastTimeElement->to = 1439;  /* set time to 23:59 */
}


/*
 * sgTimeElementAdd - add configuration time element.
 */
static void sgTimeElementAdd( 
  char * element, 
  char   type ) 
{
  struct TimeElement * te;
  char * p;
  char   wday;
  int    h, m, Y, M, D;
  time_t sec;
  char * lineptr;

  wday = 0;
  M = 0;
  D = -1;
  te = ufdbNewGV.lastTimeElement;

  switch (type)
  {
  case T_WEEKDAY:
    p = strtok_r( element, " \t,", &lineptr );
    do {
      if (*p == '*') {
	wday = 0x7F;
      } else if (!strncmp(p,"sun",3)) {
	wday = wday | 0x01;
      } else if (!strncmp(p,"mon",3)) {
	wday = wday | 0x02;
      } else if (!strncmp(p,"tue",3)) {
	wday = wday | 0x04;
      } else if (!strncmp(p,"wed",3)) {
	wday = wday | 0x08;
      } else if (!strncmp(p,"thu",3)) {
	wday = wday | 0x10;
      } else if (!strncmp(p,"fri",3)) {
	wday = wday | 0x20;
      } else if (!strncmp(p,"sat",3)) {
	wday = wday | 0x40;
      }
      p = strtok_r( NULL, " \t,", &lineptr );
    } while (p != NULL);
    te->wday = wday;
    break;

  case T_TVAL:
    h = -1;
    m = -1;
    sscanf( element, "%d:%d", &h, &m );
    if ((h < 0 || h > 24) || (m < 0 || m > 59))
    {
      ufdbLogFatalError( "line %d: time format error in %s", lineno, ufdbNewGV.configFile );
      h = 0;
      m = 0;
    }
    if (time_switch == 0) 
    {
      time_switch++;
      te->from = (h * 60) + m ;
    }
    else
    {
      time_switch = 0;
      te->to = (h * 60) + m ;
    }
    break;

  case T_DVAL:
    sec = date2sec( element );
    if (sec == -1) 
    {
      ufdbLogFatalError( "line %d: date format error in %s", lineno, ufdbNewGV.configFile );
      sec = 1;
    }
    if (date_switch == 0) {
      date_switch++;
      te->fromdate = sec;
    } else {
      date_switch = 0;
      te->todate = sec;
    }
    break;

  case T_DVALCRON:
    p = strtok_r( element, "-./", &lineptr );
    Y = atoi(p);
    if (*p == '*')
      Y = -1;
    else
      Y = atoi(p);
    while ((p=strtok_r(NULL,"-./",&lineptr)) != NULL) 
    {
      if (*p == '*')
	if (M == 0)
	  M = -1;
	else 
	  D = -1;
      else
	if (M == 0)
	  M = atoi(p);
	else
	  D = atoi(p);
    }
    te->y = Y;
    te->m = M;
    te->d = D;
    break;

  case T_WEEKLY:
    p = element;
    while (*p != '\0') 
    {
      switch (*p) {
      case 'S':
      case 's':
	wday = wday | 0x01;
	break;
      case 'M':
      case 'm':
	wday = wday | 0x02;
	break;
      case 'T':
      case 't':
	wday = wday | 0x04;
	break;
      case 'W':
      case 'w':
	wday = wday | 0x08;
	break;
      case 'H':
      case 'h':
	wday = wday | 0x10;
	break;
      case 'F':
      case 'f':
	wday = wday | 0x20;
	break;
      case 'A':
      case 'a':
	wday = wday | 0x40;
	break;
      default:
	ufdbLogFatalError( "line %d: weekday format error in %s", lineno, ufdbNewGV.configFile );
	break;
      }
      p++;
    }
    te->wday = wday;
    break;
  }

  ufdbFree( (void*) element );
}


/* 
 * lookup a ufdbTime element by name.
 */
static struct ufdbTime * sgTimeFindName( 
   const char * name )
{
   struct ufdbTime * p;

   for (p = ufdbNewGV.timeList;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }
   return NULL;
}


/*
 * sgTimeCmp - Time array sort function.
 */
static int sgTimeCmp( const void * a, const void * b )
{
   const int * aa = (const int *) a;
   const int * bb = (const int *) b;

   return *aa - *bb;
}


/*
 * _getSortedTimeElementTimes - produce a sorted array of time element times
 */
static void _getSortedTimeElementTimes( void )           // uses ufdbGV
{
   struct ufdbTime *    p;
   struct TimeElement * te;
   int                  i, j;
   int                  totalNumElems;
 
   if (ufdbGV.debug > 1)
      ufdbLogMessage( "_getSortedTimeElementEvents" );

   if (ufdbGV.timeList == NULL)
      return;

   /* find total number of time elements */
   totalNumElems = 0;
   for (p = ufdbGV.timeList;  p != NULL;  p = p->next) 
      for (te = p->element;  te != NULL;  te = te->next) 
         totalNumElems++;

   TimeElementsEvents = (int *) ufdbCalloc( totalNumElems * 2 , sizeof(int) ); 

   i = 0;
   for (p = ufdbGV.timeList;  p != NULL;  p = p->next) 
   {
      for (te = p->element;  te != NULL;  te = te->next) 
      {
         TimeElementsEvents[i++] = te->from == 0 ? 1440 : te->from;
         TimeElementsEvents[i++] = te->to == 0   ? 1440 : te->to;
      }
   }
 
   qsort( TimeElementsEvents, totalNumElems * 2, sizeof(int), sgTimeCmp );

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "   _getSortedTimeElementEvents: after qsort" );

   /* remove identical time elements */
   for (i=1,j=1;  i < totalNumElems * 2;  i++) 
   {
      if (TimeElementsEvents[i] > TimeElementsEvents[i-1])
      {
	 TimeElementsEvents[j] = TimeElementsEvents[i];
         j++;
      }
   }

   numTimeElements = j;			/* #unique time elements */
}


/*
 * _TimeEvaluateElements - evaluate all elements if they match the current time/date and mark them active.
 */
static void _TimeEvaluateElements(              // uses ufdbGV
  struct tm * tm_now, 
  time_t      now )
{
  struct ufdbTime *    tlist;
  struct TimeElement * te;
  int                  min;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "      _TimeEvaluateElements" );

  for (tlist = ufdbGV.timeList;  tlist != NULL;  tlist = tlist->next)
  {
    tlist->active = 0;
    for (te = tlist->element;  te != NULL;  te = te->next)
    {
      if (te->wday != 0) 			/* check wday */
      {
	if (((1 << tm_now->tm_wday) & te->wday) != 0)  
	{
	  min = (tm_now->tm_hour * 60) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else if (te->fromdate != 0)		/* check date */
      {
	if (now >= te->fromdate  &&  now <= te->todate) 
	{
	  min = (tm_now->tm_hour * 60) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else					/* check crondate */
      {
	if (te->y == -1  ||  te->y == (tm_now->tm_year + 1900)) 
	{
	  if (te->m == -1  ||  te->m == (tm_now->tm_mon + 1)) 
	  {
	    if (te->d == -1  ||  te->d == (tm_now->tm_mday)) 
	    {
	      min = (tm_now->tm_hour * 60) + tm_now->tm_min;
	      if (min >= te->from  &&  min < te->to) 
	      {
		tlist->active = 1;
		break;
	      }
	    }
	  }
	}
      }
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeEvaluateElements: time %s is %sactive", tlist->name, tlist->active?"":"not " );
  }
}


/*
 * _TimeSetAclSrcDestRew - mark all acl/source/dest/rew (in)active.
 */
static void _TimeSetAclSrcDestRew( void )               // uses ufdbGV
{
  struct Acl *         acl;
  struct Category *    cat;
  struct Source *      s;
  struct sgRewrite *   rew;
  int                  a;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "   _TimeSetAclSrcDestRew" );

  for (acl = ufdbGV.aclList;  acl != NULL;  acl = acl->next)
  {
    if (acl->time != NULL  &&  acl->within != UFDB_ACL_ELSE) 
    {
      /* Be careful here: we are multithreaded and other threads use the value 
       * of acl->active at the same time.
       */
      a = acl->time->active;
      if (acl->within == UFDB_ACL_OUTSIDE)
	a = !a;
      if (acl->next != NULL  &&  acl->next->within == UFDB_ACL_ELSE) 
	acl->next->active = !a;
      acl->active = a;
    }
#if 0
    if (acl->pass == NULL)
       acl->active = 0;			/* it can have a 'continue' so do not make it inactive */
#endif
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: acl %s %s is %sactive", acl->name, 
		       acl->within==UFDB_ACL_ELSE ? "ELSE" :
			  acl->within==UFDB_ACL_WITHIN ? "WITHIN" :
			     acl->within==UFDB_ACL_OUTSIDE ? "OUTSIDE" : "",
		       acl->active?"":"not " );
  }

  for (cat = ufdbGV.catList;  cat != NULL;  cat = cat->next)
  {
    if (cat->time != NULL) 
    {
      cat->active = cat->time->active;
      if (cat->within == UFDB_ACL_OUTSIDE)
	cat->active = !cat->active;
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: category %s is %sactive", cat->name, cat->active?"":"not " );
  }

  for (s = ufdbGV.sourceList;  s != NULL;  s = s->next)
  {
    if (s->time != NULL) 
    {
      s->active = s->time->active;
      if (s->within == UFDB_ACL_OUTSIDE)
	s->active = !s->active;
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: source %s is %sactive", s->name, s->active?"":"not " );
  }

  for (rew = ufdbGV.rewrite; rew != NULL; rew = rew->next)
  {
    if (rew->time != NULL) 
    {
      rew->active = rew->time->active;
      if (rew->within == UFDB_ACL_OUTSIDE)
	 rew->active = !rew->active;
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: rewrite %s is %sactive", rew->name, rew->active?"":"not " );
  }
}


static void sgAlarm( int s )
{
   if (s) { ; }         // prevent compiler warning
   // do nothing; there is a thread that waits for a SIGALRM which calls ufdbHandleAlarmForTimeEvents()
}


/*
 *  ufdbHandleAlarmForTimeEvents - the alarm for the next time event went off so 
 *                                 recalculate the time-dependent active state.
 */
void ufdbHandleAlarmForTimeEvents(              // uses ufdbGV
   int        why )
{
   time_t     now;
   struct tm  tm_now;
   int        m;
   int        tindex;
   int        lastval;

   if (ufdbGV.debug)
      ufdbLogMessage( "ufdbHandleAlarmForTimeEvents( why=%s )", why==UFDB_PARAM_INIT ? "init" : "alarm" );

   if (why == UFDB_PARAM_INIT)
      ufdbLogMessage( "time definitions are used; evaluating current ACLs" );
   else
   {
      ufdbLogMessage( "alarm went off to recalculate time ACLs" );
      if (ufdbGV.terminating)
      {
	 ufdbLogMessage( "This alarm is ignored because ufdbguardd is exiting" );
	 return;
      }
      if (ufdbGV.reconfig)
      {
	 ufdbLogMessage( "This alarm is ignored because the configuration is being reloaded"
	                 " and a new alarm is set to go off in 15 seconds" );
	 alarm( 15 );
	 return;
      }
   }

   if (ufdbGV.timeList == NULL)
   {
      return;
   }

   // NOTE: _getSortedTimeElementTimes() mallocs TimeElementsEvents[] and this function frees it.
   _getSortedTimeElementTimes();

   now = UFDBtime() + 30;
   localtime_r( &now, &tm_now ); 
   m = (tm_now.tm_hour * 60) + tm_now.tm_min;
  
   lastval = 0;
   for (tindex = 0;  tindex < numTimeElements;  tindex++)
   {
#if UFDB_TIME_DEBUG
      if (ufdbGV.debug > 1)
         ufdbLogMessage( "   TimeElementsEvents[%d] = %d", tindex, TimeElementsEvents[tindex] );
#endif
      lastval = TimeElementsEvents[tindex];
      if (TimeElementsEvents[tindex] >= m)
         break;
   }

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "   ufdbHandleAlarmForTimeEvents: m = %d  tindex = %d, lastval = %d", m, tindex, lastval );

   if (lastval < m)
      m = (((1440 - m) + TimeElementsEvents[0]) * 60) - tm_now.tm_sec;
   else
      m = ((lastval - m) * 60) - tm_now.tm_sec;

   if (m <= 0)
      m = 30;

   _TimeEvaluateElements( &tm_now, now );
   _TimeSetAclSrcDestRew();

   ufdbFree( (void*) TimeElementsEvents );
   TimeElementsEvents = NULL;

   ufdbLogMessage( "next alarm is in %d seconds", (unsigned int) m );
   ufdbSetSignalHandler( SIGALRM, sgAlarm );
   (void) alarm( (unsigned int) m );
}


/*
 * sgTimeElementClone - copy a time specification.
 */
static void sgTimeElementClone( void )
{
  struct TimeElement * te;
  struct TimeElement * tmp;

  te = ufdbNewGV.lastTimeElement;
  if (te == NULL) 
  {
    ufdbLogFatalError( "No previous TimeElement in sgTimeElementClone !" );
    return;
  }
  else
  {
    sgTimeElementInit();
    ufdbNewGV.lastTimeElement->wday = te->wday;
    ufdbNewGV.lastTimeElement->from = te->from;
    ufdbNewGV.lastTimeElement->to = te->to;
    ufdbNewGV.lastTimeElement->y = te->y;
    ufdbNewGV.lastTimeElement->m = te->m;
    ufdbNewGV.lastTimeElement->d = te->d;
    ufdbNewGV.lastTimeElement->fromdate = te->fromdate;
    ufdbNewGV.lastTimeElement->todate = te->todate;
    tmp = ufdbNewGV.lastTimeElement;
    ufdbNewGV.lastTimeElement = te;
    sgTimeElementEnd();
    ufdbNewGV.lastTimeElement = tmp;
  }
}


/*
 * IP functions
 */

static struct Ipv4 * sgIpv4Last( 
   struct Source * s )
{
   struct Ipv4 * ipv4;
   struct Ipv4 * last;

   last = NULL;
   for (ipv4 = s->ipv4;  ipv4 != NULL;  ipv4 = ipv4->next)
      last = ipv4;

   return last;
}


static void sgIpv4( 
   const char *   addr,
   int            type,
   const char *   file,
   int            lineno )
{
   struct Ipv4 *  ipv4;
   char *         addr2;
   char *         cidr;
   char *         end;
   unsigned int   octet;

#if 1
   if (ufdbGV.debug> 1)
      ufdbLogMessage( "   sgIpv4( %s %d %s %d )", addr, type, file, lineno );
#endif

   switch (type)
   {
   case SG_IPTYPE_HOST:
	 if (ufdbNewGV.lastSource->ipv4hosts == NULL)
	    ufdbNewGV.lastSource->ipv4hosts = UFDBmemDBinit();
	 UFDBmemDBinsert( ufdbNewGV.lastSource->ipv4hosts, addr, NULL );
  	 break;

   case SG_IPTYPE_RANGE:
	 addr2 = strchr( addr, '-' );
	 *addr2 = '\0';
	 end = addr2;
	 while (*(end-1) == ' '  ||  *(end-1) == '\t')
	 {
	    *(end-1) = '\0';
	    end--;
	 }
	 addr2++;
	 while (*addr2 == ' ' || *addr2 == '\t')
	    addr2++;

         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_RANGE;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (ufdbNewGV.lastSource->ipv4 == NULL) 
	    ufdbNewGV.lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( ufdbNewGV.lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s - %s", file, lineno, addr, addr2 );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (sgConvDot(addr2,&ipv4->mask) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s - %s", file, lineno, addr, addr2 );
	    ipv4->mask = 0;
	    ipv4->net_is_set = 0;
	 }

	 if ((unsigned int) ipv4->net > (unsigned int) ipv4->mask)
	     ufdbLogFatalError( "IPv4 range error in %s line %d: %s - %s", file, lineno, addr, addr2 );
  	 break;

   case SG_IPTYPE_CLASS:
	 addr2 = strchr( addr, '/' );
	 *addr2 = '\0';
	 addr2++;
         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_CLASS;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (ufdbNewGV.lastSource->ipv4 == NULL) 
	    ufdbNewGV.lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( ufdbNewGV.lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, addr2 );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (sgConvDot(addr2,&ipv4->mask) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, addr2 );
	    ipv4->mask = 0;
	 }
  	 break;

   case SG_IPTYPE_CIDR:
	 cidr = strchr( addr, '/' );
	 *cidr = '\0';
	 cidr++;
	 octet = (unsigned long) atoi( cidr );
	 if (octet > 32) 
	 {
	    ufdbLogFatalError( "IPv4 address CIDR out of range in %s line %d: %s/%s",
	                       file, lineno, addr, cidr );
	    octet = 32;
	 }
         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_CIDR;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (ufdbNewGV.lastSource->ipv4 == NULL) 
	    ufdbNewGV.lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( ufdbNewGV.lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, cidr );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (octet == 32)
	    ipv4->mask = 0xffffffff;
	 else
	    ipv4->mask = 0xffffffff ^ (0xffffffff >> octet);
	 ipv4->net = ipv4->net & ipv4->mask;
  	 break;
   }
}


static struct Ipv6 * sgIpv6Last( 
   struct Source * s )
{
   struct Ipv6 * ipv6;
   struct Ipv6 * last;

   last = NULL;
   for (ipv6 = s->ipv6;  ipv6 != NULL;  ipv6 = ipv6->next)
      last = ipv6;

   return last;
}



static void sgIpv6( 
   const char * addr,
   int          type,
   const char * file,
   int          line  )
{
#if 1
   if (ufdbGV.debug > 1)
      ufdbLogMessage( "   sgIpv6( %s %d  %s %d/%d )", addr, type, file, line, lineno );
#endif

   if (type == SG_IPV6TYPE_HOST)
   {
      struct in6_addr dummy;
      if (!sgValidateIPv6( addr, &dummy ))
      {
         ufdbLogFatalError( "incorrect IPv6 address \"%s\" in %s line %d", addr, file, lineno );
      }
      else
      {
         if (ufdbNewGV.lastSource->ipv6hosts == NULL)
	    ufdbNewGV.lastSource->ipv6hosts = UFDBmemDBinit();
	 UFDBmemDBinsert( ufdbNewGV.lastSource->ipv6hosts, addr, NULL );
      }
   }
   else if (type == SG_IPV6TYPE_CIDR)
   {
      char * s = (char*) strchr( addr, '/' );
      if (s == NULL)
      {
         ufdbLogFatalError( "IPv6 net has no '/' in \"%s\" in %s line %d", addr, file, lineno );
      }
      else
      {
	 struct Ipv6 *  ipv6;

	 ipv6 = (struct Ipv6 *) ufdbMalloc( sizeof(struct Ipv6) );
	 ipv6->type = SG_IPV6TYPE_CIDR;
	 ipv6->next = NULL;
	 if (ufdbNewGV.lastSource->ipv6 == NULL) 
	    ufdbNewGV.lastSource->ipv6 = ipv6;
	 else
	    sgIpv6Last( ufdbNewGV.lastSource )->next = ipv6;

         *s = '\0';
         ipv6->cidr = (unsigned long) atoi( s+1 );
         if (ipv6->cidr < 1  ||  ipv6->cidr > 128) 
         {
            ufdbLogFatalError( "IPv6 address CIDR out of range \"%s\" in %s line %d", addr, file, lineno );
            ipv6->cidr = 128;
         }
         if (!sgValidateIPv6( addr, &ipv6->ipv6 ))
         {
            ufdbLogFatalError( "incorrect IPv6 address \"%s\" in %s line %d", addr, file, lineno );
         }
         *s = '/';
      }
   }
   else
   {
      ufdbLogFatalError( "sgIpv6 called with unsupported type %d in %s line %d: %s", type, file, lineno, addr );
   }
}


/*
 * ACL functions
 */

static void ufdbAcl( 
   const char *    name,
   const char *    value, 
   int             within )
{
   struct Acl *    acl;
   struct Source * source;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbAcl name=\"%s\" value=\"%s\" within=%d line=%d", 
                   name==NULL?"NULL":name,  value==NULL?"NULL":value, within, lineno );
#endif

   if (ufdbNewGV.aclList != NULL) 
   {
      if (ufdbAclFindByName(&ufdbNewGV,name) != NULL)
      {
	 ufdbLogFatalError( "line %d: ACL \"%s\" is already defined in configuration file %s",
			    lineno, name, ufdbNewGV.configFile );
      }
   }

   if (within == UFDB_ACL_ELSE)
   {
      if (ufdbNewGV.lastAcl == NULL)
      {
         ufdbLogFatalError( "line %d: ACL \"else\" has no parent ACL", lineno );
         return;
      }
      if (name == NULL)
         name = ufdbStrdup( ufdbNewGV.lastAcl->name );
   }

   acl = (struct Acl *) ufdbMalloc( sizeof(struct Acl) );

   source = NULL;
   if (strcmp(name,"default") == 0)
   {
      ufdbNewGV.defaultAcl = acl;
   }
   else
   {
      if ((source = defSourceFindName(ufdbNewGV.sourceList,name)) == NULL)
      {
         ufdbLogFatalError( "line %d: ACL source \"%s\" is not defined in configuration file %s",
                            lineno, name, ufdbNewGV.configFile );
         if (ufdbNewGV.fastRefresh  &&  ufdbGV.fastRefresh  &&
             defSourceFindName(ufdbGV.sourceList,name) != NULL)
            ufdbLogError( "But ACL source \"%s\" is defined in the old configuration  *****", name );
         if (ufdbGV.debug > 1)
            UFDBlogConfig( &ufdbGV );
         ufdbFree( (void*) name );
         ufdbFree( (void*) acl );
         return;
      }
   }

   acl->name = name;
   acl->active = within == UFDB_ACL_ELSE ? 0 : 1;
   acl->source = source;
   acl->pass = NULL;
   acl->implicitPass = NULL;
   acl->hasTerminatorNone = 0;
   acl->rewriteDefault = 1;
   acl->rewrite = NULL;
   acl->redirect = NULL;
   acl->time = NULL;
   acl->within = within;
   acl->next = NULL;

   if (value != NULL) 
   {
      struct ufdbTime * t;
      if ((t = sgTimeFindName(value)) == NULL) 
      {
         ufdbLogFatalError( "line %d: ACL time %s is not defined in configuration file %s",
                            lineno, value, ufdbNewGV.configFile );
         return;
      }
      acl->time = t;
   }

   if (ufdbNewGV.aclList == NULL) 
   {
      ufdbNewGV.aclList = acl;
      ufdbNewGV.lastAcl = acl;
   }
   else
   {
      ufdbNewGV.lastAcl->next = acl;
      ufdbNewGV.lastAcl = acl;
   }
}


static void ufdbAclSetValue( 
   const char *         what,
   const char *         value, 
   int                  allowed ) 
{
   struct Category *    cat = NULL;
   struct AclCategory * aclcat;
   int                  type;
  
#if UFDB_DEBUG
   ufdbLogMessage( "ufdbAclSetValue %s %s%s", what, allowed ? "" : "!", value );
#endif

   if (ufdbNewGV.lastAcl == NULL)
   {
      ufdbLogError( "error in configuration file on line %d: "
                    "cannot set value for \"%s\" because there is no defined ACL", 
                    lineno, what );
      ufdbFree( (void*) value );
      return;
   }

   if (strcmp(what,"pass") == 0)
   {
      if (strcmp(value,"any")==0 || strcmp(value,"all")==0)
      {
         if (!allowed)
            ufdbLogFatalError( "error in configuration file on line %d: do not use '!any' or '!all'.  "
                               "Use 'none' instead.", lineno );
         type = ACL_TYPE_TERMINATOR;
         allowed = 1;
      }
      else if (strcmp(value,"none") == 0)
      {
         if (!allowed)
            ufdbLogFatalError( "error in configuration file on line %d: do not use '!none'.  "
                               "Use 'any' instead.", lineno );
         type = ACL_TYPE_TERMINATOR;
         allowed = 0;
      }
      else if (strcmp(value,"in-addr") == 0)
      {
         type = ACL_TYPE_INADDR;
      }
      else
      {
         type = ACL_TYPE_DEFAULT;
         if ((cat = ufdbCategoryFindByName(&ufdbNewGV,value)) == NULL) 
         {
	    ufdbLogFatalError( "ACL category \"%s\" (line %d) is not defined in configuration file %s",
			       value, lineno, ufdbNewGV.configFile );
            if (ufdbNewGV.fastRefresh  &&  ufdbGV.fastRefresh  &&
                ufdbCategoryFindByName(&ufdbGV,value) != NULL)
            {
               ufdbLogError( "But category \"%s\" is defined in the old configuration  *****", value );
               UFDBlogConfig( &ufdbGV );
            }
	    ufdbFree( (void*) value );
            return;
         } 
      }

      aclcat = (struct AclCategory *) ufdbMallocAligned( UFDB_CACHELINE_SIZE, sizeof(struct AclCategory) );
      aclcat->name = value;
      aclcat->cat = cat;
      aclcat->access = allowed;
      aclcat->type = type;
      aclcat->next = NULL;
      aclcat->nblocks = 0;
      aclcat->nmatches = 0;

      if (ufdbNewGV.lastAcl->pass == NULL)
         ufdbNewGV.lastAcl->pass = aclcat;
      else 
         ufdbNewGV.lastAclCategory->next = aclcat;
      ufdbNewGV.lastAclCategory = aclcat;
   }
   else if (strcmp(what,"redirect") == 0)
   {
      if (strcmp(value,"default") != 0)
         ufdbNewGV.lastAcl->redirect = value;
      else 
      {
         ufdbNewGV.lastAcl->redirect = NULL;
         ufdbFree( (void*) value );
      }
   }
   else if (strcmp(what,"rewrite") == 0)
   {
      if (strcmp(value,"none") == 0)
      {
         ufdbNewGV.lastAcl->rewriteDefault = 0;
         ufdbNewGV.lastAcl->rewrite = NULL;
      }
      else
      {
         struct sgRewrite * rewrite;

         if ((rewrite = sgRewriteFindName(value)) == NULL) 
         {
            ufdbLogFatalError( "rewrite %s is not defined in configuration file %s",
                               value, ufdbNewGV.configFile );
         }
         ufdbNewGV.lastAcl->rewriteDefault = 0;
         ufdbNewGV.lastAcl->rewrite = rewrite;
      }
      ufdbFree( (void*) value );
   }
}


struct Acl * ufdbAclFindByName( 
   struct ufdbGV * gv,
   const char *    name )
{
   struct Acl * p;

   if (name == NULL)
      return NULL;

   for (p = gv->aclList;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }

   return NULL;
}


static void logConfig( void )
{
   int    lno;
   FILE * fin;
   char   line[32678];
   
   if (ufdbNewGV.configLogged)
      return;
   ufdbNewGV.configLogged = 1;

   fin = fopen( ufdbNewGV.configFile, "r" );
   if (fin == NULL)
      return;

   ufdbLogMessage( "======== literal content of config file ========" );
   lno = 1;
   while (UFDBfgetsNoNL(line,sizeof(line)-1,fin) != NULL)
   {
      ufdbLogMessage( "%04d: %s", lno, line );
      lno++;
   }
   ufdbLogMessage( "======== end of literal content ========" );
   fclose( fin );
}


void yyerror( const char * s )
{
   ufdbLogFatalError( "line %d: %s in configuration file %s", lineno, s, ufdbNewGV.configFile );
}


int yywrap( void )
{
  return 1;
}

